---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 00_Crear_BD.sql          -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Creaci dels diferents objectes de la Base de Dades.
---------------------------------------------------------------------------------------------------
-- Parmetres: (si s'executa des de SQL Command Line, connectat amb usuari SYSTEM)
-- 		path -> Cal cridar-lo indicant al davant la ruta on es troba el script de generaci
--				d'objectes de la base de dades. Des del usuari SYSTEM
--				@@ {path}\00_Crear_BD.sql
--				Per exemple: D:\uoc\2013-2\tfc\bbdd\salcayde\00_Crear_BD.sql
---------------------------------------------------------------------------------------------------
-- L'arxiu .txt  es gravar en la carpeta on estigui aquest script dde creaci.
---------------------------------------------------------------------------------------------------

$cls

Set echo off; 
set feedback 2;
Set serveroutput on; 
Set PAGESIZE 0; 
Set LINESIZE 1000; 

spool 00_Crear_BD.txt

prompt 
prompt *** Iniciant procs de creaci dels objectes de la Base de Dades....
prompt 

prompt ******************************************************
prompt 01 Creaci dels espais per dades i indexs i del usuari
prompt ******************************************************
prompt 

@@ 01_Espais_i_Usuari.sql

prompt 
prompt ************************
prompt 02 Creaci de les taules
prompt ************************
prompt 

@@ 02_Taules.sql

prompt 
prompt ******************************
prompt 03 Creaci de les restriccions
prompt ******************************
prompt  

@@ 03_Restriccions.sql

prompt 
prompt ****************************************************
prompt 04 Creaci de les seqncies i disparadors associats
prompt ****************************************************
prompt 

@@ 04_Sequencies.sql

prompt 
prompt **********************
prompt 05 Creaci dels indexs
prompt **********************
prompt 

@@ 05_Indexs.sql

prompt
prompt ************************************************
prompt 06 Creaci de les vistes
prompt ************************************************
prompt 

@@ 06_Vistes.sql

prompt 
prompt ************************************************
prompt 07 Creaci dels procediments generals
prompt ************************************************
prompt 

@@ 07_Procediments.sql

prompt 
prompt ************************************************
prompt 08 Creaci del paquet d'estadstiques
prompt ************************************************
prompt 

@@ 08_Paquet_EST.sql

prompt 
prompt ************************************************
prompt 09 Creaci del paquet d'ABM
prompt ************************************************
prompt 

@@ 09_Paquet_ABM.sql


prompt 
prompt ************************************************
prompt 10 Creaci del paquet de consultes
prompt ************************************************
prompt 

@@ 10_Paquet_CON.sql

--prompt 
--prompt ************************************************
--prompt 11 Inserci de les dades en les taules auxiliars
--prompt ************************************************
--prompt 

--@@ 11_Ins00_Taules_Aux.sql

--prompt 
--prompt ********************************************************
--prompt 12 Inserci via procediments de les dades en les taules
--prompt ********************************************************
--prompt 

--@@ 12_Ins01_Cambres.sql
--@@ 12_Ins02_Membres.sql
--@@ 12_Ins03_Despeses_Gen.sql
--@@ 12_Ins04_Despeses_Per.sql

commit;
prompt 
prompt *** Procs de creaci dels objectes de la Base de Dades finalitzat.

prompt 
select '*** Usuari ' || user || ' el ' || to_char(sysdate,'dd/mm/yyyy hh24:mm') from dual;

Spool off; 
Set define on; 
Set feedback on;
