---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 00_Eliminar_Despeses.sql -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 15/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Eliminaci de les dades de despeses de la Base de Dades. Des del usuari SYSTEM.
---------------------------------------------------------------------------------------------------
-- Parmetres: (si s'executa des de SQL Command Line, connectat amb usuari SYSTEM)
-- 		path -> Cal cridar-lo indicant al davant la ruta on es troba el script d'eliminaci
--				d'objectes de la base de dades. 
--				@@ {path}\00_Eliminar_BD.sql
--				Per exemple: D:\uoc\2013-2\tfc\bbdd\salcayde\00_Eliminar_Despeses.sql
---------------------------------------------------------------------------------------------------
-- L'arxiu .txt  es gravar en la carpeta on estigui aquest script d'eliminaci.
---------------------------------------------------------------------------------------------------

$cls

set heading off

spool 00_Eliminar_Despeses.txt

prompt *** Iniciant procs d'eliminaci de despeses de la Base de Dades.....

prompt 
prompt ***********************************************
prompt 01 Eliminant dades de les taules estadistiques
prompt ***********************************************

DELETE FROM DCE.E1_CAMBRA_4ANYS;
DELETE FROM DCE.E2_DIFERENCIA_MEMBRES ;
DELETE FROM DCE.E3_MAX_CAMBRA;
DELETE FROM DCE.E4_MEMBRE_4ANYS ;
DELETE FROM DCE.E5_MITJANA_MEMBRE;
DELETE FROM DCE.E6_MES_MENYS_MEMBRE ;
DELETE FROM DCE.E7_MITJANA_MAX_CAMBRA;
DELETE FROM DCE.E8_TOTAL_CAMBRES ;

prompt 
prompt *********************************************
prompt 02 Eliminant dades de les taules de despeses
prompt *********************************************

DELETE FROM DCE.DESPESA_CAMBRA;
DELETE FROM DCE.DESPESA_MEMBRE;
DELETE FROM DCE.DESPESA;
DELETE FROM DCE.LOG_PROCEDIMENT WHERE PROCEDIMENT LIKE '%DESPES%';
DELETE FROM DCE.LOG_PROCEDIMENT WHERE PROCEDIMENT LIKE '%ESTADIS%';

prompt 
prompt ************************
prompt 03 Eliminant sequencies
prompt ************************

DROP SEQUENCE DCE.DES_SEQ_IBD;

prompt 
prompt ********************************
prompt 04 Creant de nou les sequencies
prompt ********************************

CREATE SEQUENCE DCE.DES_SEQ_IBD START WITH 1 NOCACHE ORDER ;

prompt 
COMMIT;

prompt 
prompt *** Procs d'eliminaci de despeses de la Base de Dades finalitzat.

prompt 
select '*** Usuari ' || user || ' el ' || to_char(sysdate,'dd/mm/yyyy hh24:mm') from dual;

spool off