---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 01_Espais_i_Usuari.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Creaci dels espais de taules i ndexs i del usuari DCE. Des del usari SYSTEM
---------------------------------------------------------------------------------------------------
-- Identificarem els objectes amb les sigles DCE (Despeses Cambres Europees)
---------------------------------------------------------------------------------------------------

-- *** CREACI DEL TABLESPACE PER A LES DADES *** --

CREATE TABLESPACE DCE_DADES DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\DCE_Dades.dbf' 
    SIZE 15M AUTOEXTEND OFF
    LOGGING ONLINE PERMANENT
    EXTENT MANAGEMENT LOCAL AUTOALLOCATE
    BLOCKSIZE 8K
    SEGMENT SPACE MANAGEMENT AUTO
    FLASHBACK ON;

-- *** CREACI DEL TABLESPACE PELS NDEXS *** --

CREATE TABLESPACE DCE_INDEXS DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\DCE_Indexs.dbf' 
    SIZE 20M AUTOEXTEND OFF
    LOGGING ONLINE PERMANENT
    EXTENT MANAGEMENT LOCAL AUTOALLOCATE
    BLOCKSIZE 8K
    SEGMENT SPACE MANAGEMENT AUTO
    FLASHBACK ON;
    
-- *** CREACI DE L'USUARI administrador DCE I ATORGAMENT DE PERMISOS *** --

CREATE USER DCE
    IDENTIFIED BY "OHEUROPA"
    DEFAULT TABLESPACE USERS
    TEMPORARY TABLESPACE TEMP
    QUOTA UNLIMITED ON DCE_DADES
    QUOTA UNLIMITED ON DCE_INDEXS
    PROFILE DEFAULT
    ACCOUNT UNLOCK;

GRANT CONNECT, RESOURCE TO DCE;
GRANT CREATE VIEW TO DCE;

-- *** CONFIRMAR TRANSACCIONS *** --
COMMIT;
---------------------------------------------------------------------------------------------------