---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 02_Taules.sql            -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Scripts de Creaci de TAULES
-- Regles de negoci: garanteix la regla de negoci 3
---------------------------------------------------------------------------------------------------

-- *** ESTATS MEMBRES *** --

CREATE TABLE DCE.ESTAT (
    IBD               NUMBER (3)     CONSTRAINT EST_NN_IBD NOT NULL,
    ESTAT             VARCHAR2 (20)  CONSTRAINT EST_NN_EST NOT NULL,
    ANY_INCORPORACIO  NUMBER (4)     CONSTRAINT EST_NN_ANY NOT NULL 
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.ESTAT IS 'Estats membres de la CE';
COMMENT ON COLUMN DCE.ESTAT.IBD IS 'Identificador bbdd del estat membre';
COMMENT ON COLUMN DCE.ESTAT.ESTAT IS 'Nom del estat membre';
COMMENT ON COLUMN DCE.ESTAT.ANY_INCORPORACIO IS 'Any d''incorporaci com a estat membre de CE';
prompt 
   	
-- *** PAISOS O REGIONS DELS ESTATS MEMBRES *** --

CREATE TABLE DCE.PAIS_REGIO (
    IBD         NUMBER (3)    CONSTRAINT PAI_REG_NN_IBD NOT NULL,
    ESTAT       NUMBER (3)    CONSTRAINT PAI_REG_NN_EST NOT NULL,
    PAIS_REGIO  VARCHAR2 (40) CONSTRAINT PAI_REG_NN_PAI NOT NULL 
) TABLESPACE DCE_DADES;
 
COMMENT ON TABLE DCE.PAIS_REGIO IS 
    'Paissos i regions dels estats membres de la CE que tenen cambra parlamentria';
COMMENT ON COLUMN DCE.PAIS_REGIO.IBD IS 'Identificador bbdd del pais o regi';
COMMENT ON COLUMN DCE.PAIS_REGIO.ESTAT IS 'Identificador bbdd del estat membre';
COMMENT ON COLUMN DCE.PAIS_REGIO.PAIS_REGIO IS 'Nom del pais o regi';
prompt  

-- *** PARTITS POLITICS *** --

CREATE TABLE DCE.PARTIT_POLITIC (
    IBD     NUMBER (3)    CONSTRAINT PAR_POL_NN_IBD NOT NULL,
    PARTIT  VARCHAR2 (70) CONSTRAINT PAR_POL_NN_PAR NOT NULL,
    SIGLES  VARCHAR2 (10) CONSTRAINT PAR_POL_NN_SIG NOT NULL 
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.PARTIT_POLITIC IS 
    'Partits poltics als quals pertanyen els membres de les cambres parlamentries';
COMMENT ON COLUMN DCE.PARTIT_POLITIC.IBD IS 'Identificador bbdd del partit poltic';
COMMENT ON COLUMN DCE.PARTIT_POLITIC.PARTIT IS 'Nom del partit poltic';
COMMENT ON COLUMN DCE.PARTIT_POLITIC.SIGLES IS 'Sigles del partit poltic';
prompt 
   	
-- *** FORMES DE PAGAMENT DE LES DESPESES *** --

CREATE TABLE DCE.FORMA_PAGAMENT (
    IBD      NUMBER (3)    CONSTRAINT FOR_PAG_NN_IBD NOT NULL,
    PAGAMENT VARCHAR2 (40) CONSTRAINT FOR_PAG_NN_PAG NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.FORMA_PAGAMENT IS 'Formes de pagament de les despeses';
COMMENT ON COLUMN DCE.FORMA_PAGAMENT.IBD IS 'Identificador bbdd de la forma de pagament';
COMMENT ON COLUMN DCE.FORMA_PAGAMENT.PAGAMENT IS 'Descripci de la forma de pagament';
prompt 
   	
-- *** SITUACIONS DE LES DESPESES *** --

CREATE TABLE DCE.SITUACIO_DESPESA (
    IBD       NUMBER (2)    CONSTRAINT SIT_DES_NN_IBD NOT NULL,
    SITUACIO  VARCHAR2 (30) CONSTRAINT SIT_DES_NN_SIT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.SITUACIO_DESPESA IS 'Situacions en les que es pot trobar una despesa';
COMMENT ON COLUMN DCE.SITUACIO_DESPESA.IBD IS 'Identificador bbdd de la situaci de la despesa';
COMMENT ON COLUMN DCE.SITUACIO_DESPESA.SITUACIO IS 'Descripci de la situaci de la despesa';
prompt 
   	
-- *** CATEGORIES DE LES DESPESES GENERALS *** --

CREATE TABLE DCE.CATEGORIA_GENERAL (
    IBD        NUMBER (3)    CONSTRAINT CAT_GEN_NN_IBD NOT NULL,
    CODI       VARCHAR2 (8)  CONSTRAINT CAT_GEN_NN_COD NOT NULL,
    CATEGORIA  VARCHAR2 (50) CONSTRAINT CAT_GEN_NN_CAT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.CATEGORIA_GENERAL IS 
    'Categories de les despeses generals de les cambres parlamentries';
COMMENT ON COLUMN DCE.CATEGORIA_GENERAL.IBD IS 'Identificador bbdd de la categoria general';
COMMENT ON COLUMN DCE.CATEGORIA_GENERAL.CODI IS 'Codificaci la categoria general';
COMMENT ON COLUMN DCE.CATEGORIA_GENERAL.CATEGORIA IS 'Descripci de la categoria general';
prompt 
   	
-- *** CATEGORIES DE LES DESPESES PERSONALS *** --

CREATE TABLE DCE.CATEGORIA_PERSONAL (
    IBD        NUMBER (3)    CONSTRAINT CAT_PER_NN_IBD NOT NULL,
    CODI       VARCHAR2 (8)  CONSTRAINT CAT_PER_NN_COD NOT NULL,
    CATEGORIA  VARCHAR2 (50) CONSTRAINT CAT_PER_NN_CAT NOT NULL
) TABLESPACE DCE_DADES ;
  
COMMENT ON TABLE DCE.CATEGORIA_PERSONAL IS 
    'Categories de les despeses personals del membres de les cambres parlamentries';
COMMENT ON COLUMN DCE.CATEGORIA_PERSONAL.IBD IS 'Identificador bbdd de la categoria personal';
COMMENT ON COLUMN DCE.CATEGORIA_PERSONAL.CODI IS 'Codificaci la categoria personal';
COMMENT ON COLUMN DCE.CATEGORIA_PERSONAL.CATEGORIA IS 'Descripci de la categoria personal';
prompt 
   	
-- *** CAMBRES PARLAMENTARIES *** --

CREATE TABLE DCE.CAMBRA (
    IBD         NUMBER (3)    CONSTRAINT CAM_NN_IBD NOT NULL,
    CAMBRA      VARCHAR2 (50) CONSTRAINT CAM_NN_CAM NOT NULL, 
    ADRECA      VARCHAR2 (50) CONSTRAINT CAM_NN_ADR NOT NULL,
    CIUTAT      VARCHAR2 (30) CONSTRAINT CAM_NN_CIU NOT NULL,
    TELEFON     VARCHAR2 (20) CONSTRAINT CAM_NN_TEL NOT NULL,
    NUM_MEMBRES NUMBER   (3)  DEFAULT 0 CONSTRAINT CAM_NN_NUM NOT NULL,
    LLOC_WEB    VARCHAR2 (50),
    DATA_BAIXA  DATE
) TABLESPACE DCE_DADES ;

COMMENT ON TABLE DCE.CAMBRA IS 'Cambres parlamentries de lal CE';
COMMENT ON COLUMN DCE.CAMBRA.IBD IS 'Identificador bbdd de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.CAMBRA IS 'Nom de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.ADRECA IS 'Adrea postal del edifici on s la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.CIUTAT IS 'Codi postal i ciutat on s la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.TELEFON IS 'Telfon de contacte de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.NUM_MEMBRES IS 'Nmero de membres en alta que formen la cambra';
COMMENT ON COLUMN DCE.CAMBRA.LLOC_WEB IS 'Adrea URL del lloc web de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA.DATA_BAIXA IS 'Data en que es dona de baixa la cambra parlamentria';
prompt 
   	
-- *** CAMBRES PARLAMENTARIES DELS ESTATS MEMBRES *** --

CREATE TABLE DCE.CAMBRA_ESTAT (
    CAMBRA NUMBER (3) CONSTRAINT CAM_EST_NN_CAM NOT NULL,
    ESTAT  NUMBER (3) CONSTRAINT CAM_EST_NN_EST NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.CAMBRA_ESTAT IS 'Cambres parlamentries associades als estats membres';
COMMENT ON COLUMN DCE.CAMBRA_ESTAT.CAMBRA IS 'Identificador bbdd de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA_ESTAT.ESTAT IS 'Identificador bbdd del estat membre';
prompt 
   	
-- *** CAMBRES PARLAMENTARIES DELS PAISOS O REGIONS *** --

CREATE TABLE DCE.CAMBRA_PAIS_REGIO (
    CAMBRA      NUMBER (3) CONSTRAINT CAM_PAI_REG_NN_CAM NOT NULL,
    PAIS_REGIO  NUMBER (3) CONSTRAINT CAM_PAI_REG_NN_PAI NOT NULL
) TABLESPACE DCE_DADES;
    
COMMENT ON TABLE DCE.CAMBRA_PAIS_REGIO IS 
    'Cambres parlamentries associades als diferents paissos i regions d''un estat membre';
COMMENT ON COLUMN DCE.CAMBRA_PAIS_REGIO.CAMBRA IS 'Identificador bbdd de la cambra parlamentria';
COMMENT ON COLUMN DCE.CAMBRA_PAIS_REGIO.PAIS_REGIO IS 'Identificador bbdd del pais o regi';
prompt 
   	
-- *** MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

CREATE TABLE DCE.MEMBRE_CAMBRA (
    IBD         NUMBER (5)    CONSTRAINT MEM_CAM_NN_IBD NOT NULL,
    CODI        VARCHAR2 (12) CONSTRAINT MEM_CAM_NN_COD NOT NULL,
    NOM         VARCHAR2 (20) CONSTRAINT MEM_CAM_NN_NOM NOT NULL,
    COGNOMS     VARCHAR2 (50) CONSTRAINT MEM_CAM_NN_COG NOT NULL,
    TELEFON     VARCHAR2 (14) CONSTRAINT MEM_CAM_NN_TEL NOT NULL,
    EMAIL       VARCHAR2 (50) CONSTRAINT MEM_CAM_NN_EMA NOT NULL,
    PARTIT      NUMBER (3)    CONSTRAINT MEM_CAM_NN_PAR NOT NULL,
    CAMBRA      NUMBER (3)    CONSTRAINT MEM_CAM_NN_CAM NOT NULL,
    NUMERO      NUMBER (3)    CONSTRAINT MEM_CAM_NN_NUM NOT NULL,
    DATA_BAIXA  DATE
) TABLESPACE DCE_DADES;
   
COMMENT ON TABLE DCE.MEMBRE_CAMBRA IS 'Membres de les cambres parlamentries';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.IBD IS 'Identificador bbdd del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.CODI IS 'Identificador (NIF, etc.) del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.NOM IS 'Nom del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.COGNOMS IS 'Cognoms del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.TELEFON IS 'Telfon de contacte del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.EMAIL IS 
    'Adrea electrnica de contacte del membre d''una cambra';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.PARTIT IS 
    'Identificador bbdd del partit poltic del que forma part';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.CAMBRA IS 
    'Identificador bbdd de la cambra parlamentria de la que forma part';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.NUMERO IS 
    'Nmero o codi que l''identifica en la cambra parlamentria';
COMMENT ON COLUMN DCE.MEMBRE_CAMBRA.DATA_BAIXA IS 
    'Data en que es dona de baixa el membre d''una cambra';
prompt 
   	
-- *** DESPESES *** --

CREATE TABLE DCE.DESPESA (
    IBD             NUMBER (9)      CONSTRAINT DES_NN_IBD NOT NULL,
    DATA_DESPESA    DATE            CONSTRAINT DES_NN_DAT NOT NULL,
    IMPORT_BRUT     NUMBER (12,2)   CONSTRAINT DES_NN_IMP NOT NULL,
    TIPUS_IVA       NUMBER (5,2)    CONSTRAINT DES_NN_TIP NOT NULL,
    IMPORT_IVA      NUMBER(12,2) GENERATED ALWAYS AS (IMPORT_BRUT*TIPUS_IVA/100) VIRTUAL, 
    IMPORT_NET      NUMBER(12,2) GENERATED ALWAYS AS (IMPORT_BRUT+(IMPORT_BRUT*TIPUS_IVA/100)) VIRTUAL, 
    DESCRIPCIO      VARCHAR2 (50)   CONSTRAINT DES_NN_DES NOT NULL,
    JUSTIFICACIO    VARCHAR2 (50)   CONSTRAINT DES_NN_JUS NOT NULL,
    PAGAMENT        NUMBER (3)      CONSTRAINT DES_NN_PAG NOT NULL,
    SITUACIO        NUMBER (2)      CONSTRAINT DES_NN_SIT NOT NULL,
    PROVEIDOR       VARCHAR2 (12),
    URL_ESCANEIG    VARCHAR2 (50)
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.DESPESA IS 'Despeses';
COMMENT ON COLUMN DCE.DESPESA.IBD IS 'Identificador bbdd de la despesa';
COMMENT ON COLUMN DCE.DESPESA.DATA_DESPESA IS 'Data de la despesa';
COMMENT ON COLUMN DCE.DESPESA.IMPORT_BRUT IS 'Import brut sense IVA de la despesa';
COMMENT ON COLUMN DCE.DESPESA.TIPUS_IVA IS 'Percentatge del IVA de la despesa';
COMMENT ON COLUMN DCE.DESPESA.IMPORT_IVA IS 'Import del IVA de la despesa';
COMMENT ON COLUMN DCE.DESPESA.IMPORT_NET IS 'Import net amb IVA de la despesa';
COMMENT ON COLUMN DCE.DESPESA.DESCRIPCIO IS 
    'Descripci detallada de la despesa, que indica QU s''ha adquirit';
COMMENT ON COLUMN DCE.DESPESA.JUSTIFICACIO IS 
    'Text que indica PER QU es considera necessari efectuar la despesa';
COMMENT ON COLUMN DCE.DESPESA.PAGAMENT IS 'Identificador bbdd de la forma de pagament';
COMMENT ON COLUMN DCE.DESPESA.SITUACIO IS 'Identificador bbdd de la situaci de la despesa';
COMMENT ON COLUMN DCE.DESPESA.PROVEIDOR IS 'Identificador (NIF, etc) del provedor';
COMMENT ON COLUMN DCE.DESPESA.URL_ESCANEIG IS 
    'URL amb la informaci escanejada del pressupost, contracte i factura associada a la despesa';
prompt 

-- *** DESPESES DE LES CAMBRES PARLAMENTARIES *** --

CREATE TABLE DCE.DESPESA_CAMBRA (
    DESPESA         NUMBER (9)      CONSTRAINT DES_CAM_NN_DES NOT NULL,
    CAMBRA          NUMBER (3)      CONSTRAINT DES_CAM_NN_CAM NOT NULL,
    CATEGORIA       NUMBER (3)      CONSTRAINT DES_CAM_NN_CAT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.DESPESA_CAMBRA IS 'Despeses generals de les cambres parlamentries';
COMMENT ON COLUMN DCE.DESPESA_CAMBRA.DESPESA IS 'Identificador bbdd de la despesa';
COMMENT ON COLUMN DCE.DESPESA_CAMBRA.CAMBRA IS 'Identificador bbdd de la cambra que fa la despesa';
COMMENT ON COLUMN DCE.DESPESA_CAMBRA.CATEGORIA IS 'Identificador bbdd de la categoria general';
prompt 
      	
-- *** DESPESES PERSONALS DELS MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

CREATE TABLE DCE.DESPESA_MEMBRE (
    DESPESA         NUMBER (9)      CONSTRAINT DES_MEM_NN_DES NOT NULL,
    MEMBRE          NUMBER (3)      CONSTRAINT DES_MEM_NN_MEM NOT NULL,
    PARTIT          NUMBER (3)      CONSTRAINT DES_MEM_NN_PAR NOT NULL,
    CATEGORIA       NUMBER (3)      CONSTRAINT DES_MEM_NN_CAT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.DESPESA_MEMBRE IS 
    'Despeses personals dels membres de les cambres parlamentries';
COMMENT ON COLUMN DCE.DESPESA_MEMBRE.DESPESA IS 'Identificador bbdd de la despesa';
COMMENT ON COLUMN DCE.DESPESA_MEMBRE.MEMBRE IS 'Identificador bbdd del membre que fa la despesa';
COMMENT ON COLUMN DCE.DESPESA_MEMBRE.PARTIT IS 
    'Identificador bbdd del partit poltic al que pertany el membre que fa la despesa';
COMMENT ON COLUMN DCE.DESPESA_MEMBRE.CATEGORIA IS 'Identificador bbdd de la categoria general';
prompt 
   	        
-- *** REGISTRE D'EXECUCIO DE PROCEDIMENTS *** --

CREATE TABLE DCE.LOG_PROCEDIMENT ( 
    IBD         NUMBER (12) CONSTRAINT LOG_PRO_NN_IBD NOT NULL , 
    PROCEDIMENT VARCHAR2 (100) CONSTRAINT LOG_PRO_NN_PRO NOT NULL , 
    RESULTAT    VARCHAR2 (256) CONSTRAINT LOG_PRO_NN_RES NOT NULL ,
    ES_ERROR    CHAR(1) CONSTRAINT LOG_PRO_NN_ERR NOT NULL , 
    ENTRADA     VARCHAR2 (1024) CONSTRAINT LOG_PRO_NN_ENT NOT NULL ,
    ABANS       VARCHAR2 (1024) ,
    DESPRES     VARCHAR2 (1024) ,
    USUARI      VARCHAR2 (12) CONSTRAINT LOG_PRO_NN_USE NOT NULL , 
    DATA_HORA   TIMESTAMP CONSTRAINT LOG_PRO_NN_DAT NOT NULL 
) TABLESPACE DCE_DADES; 

COMMENT ON TABLE DCE.LOG_PROCEDIMENT IS 'Registre d''execuci de procediments.';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.IBD IS 'Identificador bbdd del registre de procediment';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.PROCEDIMENT IS 'Nom del procediment executat';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.ENTRADA IS 'Parmetres d''entrada del procediment executat';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.RESULTAT IS 'Resultat de l''execuci del procediment';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.ABANS IS 
    'Valor dels camps abans d''executar el procediment (modificacions)';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.DESPRES IS 
    'Valor dels camps desprs d''executar el procediment (modificacions)';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.ES_ERROR IS 
    'Indicador de si hi ha error en l''execuci del procediment';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.USUARI IS 'Usuari que ha executat el procediment';
COMMENT ON COLUMN DCE.LOG_PROCEDIMENT.DATA_HORA IS 
   'Data i hora en que s''ha executat el procediment';
prompt 

-- *** ESTADSTICA 1 *** --
-- *** Donada una cambra parlamentria: Suma de totes les despeses dels darrers 4 anys.

CREATE TABLE DCE.E1_CAMBRA_4ANYS (
    CAMBRA   NUMBER (3) CONSTRAINT E1_CAM_4AN_NN_CAM NOT NULL ,
    DESPESA  NUMBER (14,2) CONSTRAINT E1_CAM_4AN_NN_DES NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E1_CAMBRA_4ANYS IS
  'Donada una cambra parlamentria: Suma de totes les despeses dels darrers 4 anys';
COMMENT ON COLUMN DCE.E1_CAMBRA_4ANYS.CAMBRA IS 'Identificador bbdd de la cambra';
COMMENT ON COLUMN DCE.E1_CAMBRA_4ANYS.DESPESA IS 'Suma de totes les despeses dels darrers 4 anys';
prompt 

-- *** ESTADSTICA 2 *** --
-- *** Donats una cambra parlamentria i un any: Diferncia en euros entre el membre de la cambra
--     que ms despeses associades t i el que menys.

CREATE TABLE DCE.E2_DIFERENCIA_MEMBRES (
    CAMBRA        NUMBER (3) CONSTRAINT E2_DIF_MEM_NN_CAM NOT NULL ,
    EXERCICI      NUMBER (4) CONSTRAINT E2_DIF_MEM_NN_EXE NOT NULL ,
    MEMBRE_MES    NUMBER (5) CONSTRAINT E2_DIF_MEM_NN_MEM_MES NOT NULL ,
    MEMBRE_MENYS  NUMBER (5) CONSTRAINT E2_DIF_MEM_NN_MEM_MEN NOT NULL ,
    DESPESA_MES   NUMBER (14,2) CONSTRAINT E2_DIF_MEM_NN_DES_MES NOT NULL ,
    DESPESA_MENYS NUMBER (14,2) CONSTRAINT E2_DIF_MEM_NN_DS_MEN NOT NULL ,
    DIFERENCIA    NUMBER (14,2) CONSTRAINT E2_DIF_MEM_NN_DIF NOT NULL
  ) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E2_DIFERENCIA_MEMBRES IS
    'Donats una cambra parlamentria i un any: Diferncia en euros entre el membre de la cambra
 que ms despeses associades t i el que menys.';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.CAMBRA IS 'Identificador bbdd de la cambra';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.MEMBRE_MES IS 
   'Identificador del membre amb ms despeses';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.MEMBRE_MENYS IS 
    'Identificador del membre amb menys despeses';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.DESPESA_MES IS 
    'Suma de totes les despeses del membre que ms en t';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.DESPESA_MENYS IS 
    'Suma de totes les despeses del membre que menys en t';
COMMENT ON COLUMN DCE.E2_DIFERENCIA_MEMBRES.DIFERENCIA IS 'Diferncia de les sumes';
prompt 

-- *** ESTADSTICA 3 *** --
-- *** Donat un any: la cambra parlamentria que ha tingut un total de despeses ms alt,
--     incloent les despeses generals de la cambra i les despeses personals dels seus membres.

CREATE TABLE DCE.E3_MAX_CAMBRA (
    CAMBRA   NUMBER (3) CONSTRAINT E3_MAX_CAM_NN_CAM NOT NULL ,
    EXERCICI NUMBER (4) CONSTRAINT E3_MAX_CAM_NN_EXE NOT NULL ,
    DESPESA  NUMBER (14,2) CONSTRAINT E3_MAX_CAM_NN_DES NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E3_MAX_CAMBRA IS
   'Donat un any: la cambra parlamentria que ha tingut un total de despeses ms alt,
 incloent les despeses generals de la cambra i les despeses personals dels seus membres.' ;
COMMENT ON COLUMN DCE.E3_MAX_CAMBRA.CAMBRA IS 'Identificador bbdd de la cambra';
COMMENT ON COLUMN DCE.E3_MAX_CAMBRA.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E3_MAX_CAMBRA.DESPESA IS 'Suma total de les despeses';
prompt 

-- *** ESTADSTICA 4 *** --
-- *** Donat un membre d'una cambra: la despesa total que ha tingut els darrers 4 anys.

CREATE TABLE DCE.E4_MEMBRE_4ANYS (
    MEMBRE   NUMBER (5) CONSTRAINT E4_MEM_4AN_NN_MEM NOT NULL ,
    DESPESA  NUMBER (14,2) CONSTRAINT E4_MEM_4AN_NN_DES NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E4_MEMBRE_4ANYS IS 
    'Donat un membre d''una cambra: la despesa total que ha tingut els darrers 4 anys';
COMMENT ON COLUMN DCE.E4_MEMBRE_4ANYS.MEMBRE IS 'Identificador bbdd d''un membre d''una cambra';
COMMENT ON COLUMN DCE.E4_MEMBRE_4ANYS.DESPESA IS 'Suma de totes les despeses dels darres 4 anys';
prompt 

-- *** ESTADSTICA 5 *** --
-- *** Donat un any: la despesa mitjana d'un membre d'una cambra, tenint en compte tots els 
--     membres de totes les cambres';

CREATE TABLE DCE.E5_MITJANA_MEMBRE (
    EXERCICI NUMBER (4) CONSTRAINT E5_MIT_MEM_NN_MEM NOT NULL ,
    MITJANA  NUMBER (14,2) CONSTRAINT E5_MIT_MEM_NN_MIT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E5_MITJANA_MEMBRE IS 
    'Donat un any: la despesa mitjana d''un membre d''una cambra, 
 tenint en compte tots els membres de totes les cambres';
COMMENT ON COLUMN DCE.E5_MITJANA_MEMBRE.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E5_MITJANA_MEMBRE.MITJANA IS 'Despesa mitjana d''un membre';
prompt 

-- *** ESTADSTICA 6 *** --
-- *** Donat un any: el membre d'una cambra que ha tingut ms despesa associada i el que menys,
--     tenint en compte totes les cambres';

CREATE TABLE DCE.E6_MES_MENYS_MEMBRE (
    EXERCICI      NUMBER (4) CONSTRAINT E6_MES_MEN_MEM_NN_EXE NOT NULL ,
    MEMBRE_MES    NUMBER (5) CONSTRAINT E6_MES_MEN_MEM_NN_MEM_MES NOT NULL ,
    MEMBRE_MENYS  NUMBER (5) CONSTRAINT E6_MES_MEN_MEM_NN_MEM_MEN NOT NULL ,
    DESPESA_MES   NUMBER (14,2) CONSTRAINT E6_MES_MEN_MEM_NN_DES_MES NOT NULL ,
    DESPESA_MENYS NUMBER (14,2) CONSTRAINT E6_MES_MEN_MEM_NN_DES_MEN NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E6_MES_MENYS_MEMBRE IS 
    'Donat un any: el membre d''una cambra que ha tingut ms despesa associada i el que menys,
 tenint en compte tots els membres de totes les cambres';
COMMENT ON COLUMN DCE.E6_MES_MENYS_MEMBRE.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E6_MES_MENYS_MEMBRE.MEMBRE_MES IS 
    'Identificador del membre amb ms despesa associada';
COMMENT ON COLUMN DCE.E6_MES_MENYS_MEMBRE.MEMBRE_MENYS IS 
    'Identificador del membre amb ms despesa associada'; 
COMMENT ON COLUMN DCE.E6_MES_MENYS_MEMBRE.DESPESA_MES IS 
    'Suma de totes les despeses del membre que ms en t';
COMMENT ON COLUMN DCE.E6_MES_MENYS_MEMBRE.DESPESA_MENYS IS 
    'Suma de totes les despeses del membre que menys en t';
prompt 
    
-- *** ESTADSTICA 7 *** --
-- *** Donat un any: cambra parlamentria amb una mitjana de despesa associada als seus membres
--     ms alta, i el valor d'aquesta mitjana.

CREATE TABLE DCE.E7_MITJANA_MAX_CAMBRA (
    EXERCICI NUMBER (4) CONSTRAINT E7_MIT_MAX_CAM_NN_EXE NOT NULL ,
    CAMBRA   NUMBER (3) CONSTRAINT E7_MIT_MAX_CAM_NN_CAM NOT NULL ,
    MITJANA  NUMBER (14,2) CONSTRAINT E7_MIT_MAX_CAM_NN_MIT NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E7_MITJANA_MAX_CAMBRA IS 
   'Donat un any: cambra parlamentria amb una mitjana de despesa associada als seus membres
 ms alta, i el valor d''aquesta mitjana';
COMMENT ON COLUMN DCE.E7_MITJANA_MAX_CAMBRA.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E7_MITJANA_MAX_CAMBRA.CAMBRA IS 'Identificador bbdd de la cambra';
COMMENT ON COLUMN DCE.E7_MITJANA_MAX_CAMBRA.MITJANA IS 'Valor de la mitjana ms alta';
prompt 
   
-- *** ESTADSTICA 8 *** --
-- *** Donat un any: la suma de totes les despeses de totes les cambres, incloent les despeses
--     generals de les cambres i les despeses associades als seus membres.

CREATE TABLE DCE.E8_TOTAL_CAMBRES (
    EXERCICI NUMBER (4) CONSTRAINT E8_TOT_CAM_NN_EXE NOT NULL ,
    DESPESA  NUMBER (14,2) CONSTRAINT E8_TOT_CAM_NN_DES NOT NULL
) TABLESPACE DCE_DADES;

COMMENT ON TABLE DCE.E8_TOTAL_CAMBRES IS 
    'Donat un any: la suma de totes les despeses de totes les cambres, incloent les despeses
 generals de les cambres i les despeses associades als seus membres';
COMMENT ON COLUMN DCE.E8_TOTAL_CAMBRES.EXERCICI IS 'Any de l''estadstica';
COMMENT ON COLUMN DCE.E8_TOTAL_CAMBRES.DESPESA IS 'Suma de totes les despeses';

-- *** CONFIRMAR TRANSACCIONS *** --
COMMIT;
prompt  

select count(*) AS "Total",' TAULES DCE CREADES : ' AS "Taules" 
    from all_tables where owner = 'DCE';

set heading on;
select t.table_name as "TAULA", substr(t.tablespace_name,1,10) as "ESPAI", 
    substr(c.comments,1,180) as "DESCRIPCI" from all_tables t 
    left join all_tab_comments c on t.owner = c.owner and 
    t.table_name = c.table_name where t.owner='DCE' order by 1;
set heading off;
---------------------------------------------------------------------------------------------------