---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 03_Restriccions.sql      -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Scripts de Creaci de RESTRICCIONS
---------------------------------------------------------------------------------------------------

-- *** ESTATS MEMBRES *** --

ALTER TABLE DCE.ESTAT ADD CONSTRAINT EST_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.ESTAT ADD CONSTRAINT EST_UN_EST UNIQUE (ESTAT) 
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** PAISOS O REGIONS DELS ESTATS MEMBRES *** --

ALTER TABLE DCE.PAIS_REGIO ADD CONSTRAINT PAI_REG_PK_IBD PRIMARY KEY (IBD) 
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.PAIS_REGIO ADD CONSTRAINT PAI_REG_UN_EST_PAI UNIQUE (ESTAT, PAIS_REGIO)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.PAIS_REGIO ADD CONSTRAINT PAI_REG_FK_EST
    FOREIGN KEY(ESTAT) REFERENCES DCE.ESTAT(IBD);

-- *** PARTITS POLITICS *** --

ALTER TABLE DCE.PARTIT_POLITIC ADD CONSTRAINT PAR_POL_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.PARTIT_POLITIC ADD CONSTRAINT PAR_POL_UN_PAR UNIQUE (PARTIT)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** FORMES DE PAGAMENT DE LES DESPESES *** --

ALTER TABLE DCE.FORMA_PAGAMENT ADD CONSTRAINT FOR_PAG_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.FORMA_PAGAMENT ADD CONSTRAINT FOR_PAG_UN_PAG UNIQUE (PAGAMENT)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** SITUACIONS DE LES DESPESES *** --

ALTER TABLE DCE.SITUACIO_DESPESA ADD CONSTRAINT SIT_DES_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.SITUACIO_DESPESA ADD CONSTRAINT SIT_DES_UN_SIT UNIQUE (SITUACIO)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** CATEGORIES DE LES DESPESES GENERALS *** --

ALTER TABLE DCE.CATEGORIA_GENERAL ADD CONSTRAINT CAT_GEN_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CATEGORIA_GENERAL ADD CONSTRAINT CAT_GEN_UN_COD UNIQUE (CODI)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CATEGORIA_GENERAL ADD CONSTRAINT CAT_GEN_UN_CAT UNIQUE (CATEGORIA)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** CATEGORIES DE LES DESPESES PERSONALS *** --

ALTER TABLE DCE.CATEGORIA_PERSONAL ADD CONSTRAINT CAT_PER_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CATEGORIA_PERSONAL ADD CONSTRAINT CAT_PER_UN_COD UNIQUE (CODI)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CATEGORIA_PERSONAL ADD CONSTRAINT CAT_PER_UN_CAT UNIQUE (CATEGORIA)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** CAMBRES PARLAMENTARIES *** --

ALTER TABLE DCE.CAMBRA ADD CONSTRAINT CAM_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CAMBRA ADD CONSTRAINT CAM_UN_CAM UNIQUE (CAMBRA)
    USING INDEX TABLESPACE DCE_INDEXS;

-- *** CAMBRES PARLAMENTARIES DELS ESTATS MEMBRES *** --

ALTER TABLE DCE.CAMBRA_ESTAT ADD CONSTRAINT CAM_EST_PK_CAMBRA PRIMARY KEY (CAMBRA)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CAMBRA_ESTAT ADD CONSTRAINT CAM_EST_FK_CAM
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);
ALTER TABLE DCE.CAMBRA_ESTAT ADD CONSTRAINT CAM_EST_FK_EST
    FOREIGN KEY (ESTAT) REFERENCES DCE.ESTAT (IBD);

-- *** CAMBRES PARLAMENTARIES DELS PAISOS O REGIONS *** --

ALTER TABLE DCE.CAMBRA_PAIS_REGIO ADD CONSTRAINT 
    CAM_PAI_REG_PK_CAMBRA PRIMARY KEY (CAMBRA) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.CAMBRA_PAIS_REGIO ADD CONSTRAINT CAM_PAI_REG_FK_CAM
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);
ALTER TABLE DCE.CAMBRA_PAIS_REGIO ADD CONSTRAINT CAM_PAI_REG_FK_PAI_REG
    FOREIGN KEY (PAIS_REGIO) REFERENCES DCE.PAIS_REGIO (IBD);

-- *** MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

ALTER TABLE DCE.MEMBRE_CAMBRA ADD CONSTRAINT MEM_CAM_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.MEMBRE_CAMBRA ADD CONSTRAINT MEM_CAM_UN_COD_CAM UNIQUE (CODI, CAMBRA)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.MEMBRE_CAMBRA ADD CONSTRAINT MEM_CAM_UN_CAM_NUM UNIQUE (CAMBRA, NUMERO)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.MEMBRE_CAMBRA ADD CONSTRAINT MEM_CAM_FK_CAM
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);
ALTER TABLE DCE.MEMBRE_CAMBRA ADD CONSTRAINT MEM_CAM_FK_PAR
    FOREIGN KEY (PARTIT) REFERENCES DCE.PARTIT_POLITIC (IBD);

-- *** DESPESES *** --

ALTER TABLE DCE.DESPESA ADD CONSTRAINT DES_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.DESPESA ADD CONSTRAINT DES_FK_PAG 
    FOREIGN KEY (PAGAMENT) REFERENCES DCE.FORMA_PAGAMENT (IBD);
ALTER TABLE DCE.DESPESA ADD CONSTRAINT DES_FK_SIT
    FOREIGN KEY (SITUACIO) REFERENCES DCE.SITUACIO_DESPESA (IBD);

-- *** DESPESES GENERALS DE LES CAMBRES PARLAMENTARIES *** --

ALTER TABLE DCE.DESPESA_CAMBRA ADD CONSTRAINT DES_CAM_PK_DES PRIMARY KEY (DESPESA)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.DESPESA_CAMBRA ADD CONSTRAINT DES_CAM_FK_DES
    FOREIGN KEY (DESPESA) REFERENCES DCE.DESPESA (IBD);
ALTER TABLE DCE.DESPESA_CAMBRA ADD CONSTRAINT DES_CAM_FK_CAM 
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);
ALTER TABLE DCE.DESPESA_CAMBRA ADD CONSTRAINT DES_CAM_FK_CAT
    FOREIGN KEY (CATEGORIA) REFERENCES DCE.CATEGORIA_GENERAL (IBD);

-- *** DESPESES PERSONALS DELS MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

ALTER TABLE DCE.DESPESA_MEMBRE ADD CONSTRAINT DES_MEM_PK_DES PRIMARY KEY (DESPESA)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.DESPESA_MEMBRE ADD CONSTRAINT DES_MEM_FK_DES
    FOREIGN KEY (DESPESA) REFERENCES DCE.DESPESA (IBD);
ALTER TABLE DCE.DESPESA_MEMBRE ADD CONSTRAINT DES_MEM_FK_MEM
    FOREIGN KEY (MEMBRE) REFERENCES DCE.MEMBRE_CAMBRA (IBD);
ALTER TABLE DCE.DESPESA_MEMBRE ADD CONSTRAINT DES_MEM_FK_PAR
    FOREIGN KEY (PARTIT) REFERENCES DCE.PARTIT_POLITIC (IBD);
ALTER TABLE DCE.DESPESA_MEMBRE ADD CONSTRAINT DES_MEM_FK_CAT
    FOREIGN KEY (CATEGORIA) REFERENCES DCE.CATEGORIA_PERSONAL (IBD);

-- *** REGISTRE D'EXECUCIO DE PROCEDIMENTS *** --

ALTER TABLE DCE.LOG_PROCEDIMENT ADD CONSTRAINT LOG_PRO_PK_IBD PRIMARY KEY (IBD)
    USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.LOG_PROCEDIMENT ADD CONSTRAINT LOG_PRO_CK_ES_ERROR 
    CHECK (ES_ERROR IN ('S', 'N'));

-- *** ESTADSTICA 1 *** --
-- *** Donada una cambra parlamentria: Suma de totes les despeses dels darrers 4 anys.

ALTER TABLE DCE.E1_CAMBRA_4ANYS ADD CONSTRAINT E1_CAM_4AN_PK_CAM
    PRIMARY KEY (CAMBRA) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E1_CAMBRA_4ANYS ADD CONSTRAINT E1_CAM_FK_CAM 
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);

-- *** ESTADSTICA 2 *** --
-- *** Donats una cambra parlamentria i un any: Diferncia en euros entre el membre de la cambra
--     que ms despeses associades t i el que menys.

ALTER TABLE DCE.E2_DIFERENCIA_MEMBRES ADD CONSTRAINT E2_DIF_MEM_PK_CAM_EXE PRIMARY KEY
    (CAMBRA, EXERCICI) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E2_DIFERENCIA_MEMBRES ADD CONSTRAINT E2_CAM_FK_CAM 
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);
ALTER TABLE DCE.E2_DIFERENCIA_MEMBRES ADD CONSTRAINT E2_MEM_MEN_FK_MEM_MEN 
    FOREIGN KEY (MEMBRE_MENYS) REFERENCES DCE.MEMBRE_CAMBRA (IBD);
ALTER TABLE DCE.E2_DIFERENCIA_MEMBRES ADD CONSTRAINT E2_MEM_MES_FK_MEM_MES 
    FOREIGN KEY (MEMBRE_MES) REFERENCES DCE.MEMBRE_CAMBRA (IBD);

-- *** ESTADSTICA 3 *** --
-- *** Donat un any: la cambra parlamentria que ha tingut un total de despeses ms alt,
--     incloent les despeses generals de la cambra i les despeses personals dels seus membres.

ALTER TABLE DCE.E3_MAX_CAMBRA ADD CONSTRAINT E3_MAX_CAM_PK_CAM_EXE 
    PRIMARY KEY (CAMBRA, EXERCICI) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E3_MAX_CAMBRA ADD CONSTRAINT E3_CAM_FK_CAM 
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);

-- *** ESTADSTICA 4 *** --
-- *** Donat un membre d'una cambra: la despesa total que ha tingut els darrers 4 anys.

ALTER TABLE DCE.E4_MEMBRE_4ANYS ADD CONSTRAINT E4_MEM_4AN_PK_MEM
    PRIMARY KEY (MEMBRE) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E4_MEMBRE_4ANYS ADD CONSTRAINT E4_MEM_FK_MEM 
    FOREIGN KEY (MEMBRE) REFERENCES DCE.MEMBRE_CAMBRA (IBD);

-- *** ESTADSTICA 5 *** --
-- *** Donat un any: la despesa mitjana d'un membre d'una cambra, tenint en compte tots els 
--     membres de totes les cambres';

ALTER TABLE DCE.E5_MITJANA_MEMBRE ADD CONSTRAINT E5_MIT_MEM_PK 
    PRIMARY KEY (EXERCICI) USING INDEX TABLESPACE DCE_INDEXS;

-- *** ESTADSTICA 6 *** --
-- *** Donat un any: el membre d'una cambra que ha tingut ms despesa associada i el que menys,
--     tenint en compte totes les cambres';

ALTER TABLE DCE.E6_MES_MENYS_MEMBRE ADD CONSTRAINT E6_MES_MEN_MEM_PK_EXE 
    PRIMARY KEY (EXERCICI) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E6_MES_MENYS_MEMBRE ADD CONSTRAINT E6_MEM_MEN_FK_MEM_MEN 
    FOREIGN KEY (MEMBRE_MENYS) REFERENCES DCE.MEMBRE_CAMBRA (IBD);
ALTER TABLE DCE.E6_MES_MENYS_MEMBRE ADD CONSTRAINT E6_MEM_MES_FK_MEM_MES 
    FOREIGN KEY (MEMBRE_MES) REFERENCES DCE.MEMBRE_CAMBRA (IBD);

-- *** ESTADSTICA 7 *** --
-- *** Donat un any: cambra parlamentria amb una mitjana de despesa associada als seus membres
--     ms alta, i el valor d'aquesta mitjana.

ALTER TABLE DCE.E7_MITJANA_MAX_CAMBRA ADD CONSTRAINT E7_MIT_MAX_CAM_PK_EXE_CAM 
    PRIMARY KEY (EXERCICI, CAMBRA) USING INDEX TABLESPACE DCE_INDEXS;
ALTER TABLE DCE.E7_MITJANA_MAX_CAMBRA ADD CONSTRAINT E7_CAM_FK_CAM 
    FOREIGN KEY (CAMBRA) REFERENCES DCE.CAMBRA (IBD);

-- *** ESTADSTICA 8 *** --
-- *** Donat un any: la suma de totes les despeses de totes les cambres, incloent les despeses
--     generals de les cambres i les despeses associades als seus membres.

ALTER TABLE DCE.E8_TOTAL_CAMBRES ADD CONSTRAINT E8_TOT_CAM_PK 
    PRIMARY KEY (EXERCICI) USING INDEX TABLESPACE DCE_INDEXS;

-- *** CONFIRMAR TRANSACCIONS *** --
COMMIT;
prompt  

select count(*) as "Total", ' RESTRICCIONS DCE CREADES :' as "Restriccions"
    from all_constraints where owner = 'DCE';

set heading on
select table_name AS "TAULA", 
decode(constraint_type,
      'P','CLAU PRIMRIA',
      'U','CLAU NICA',
      'C','VALIDACI',
      'R','CLAU FORANA','ALTRE') AS "TIPUS",
constraint_name AS "RESTRICCI", 
NVL(r_constraint_name,' ') AS "CONDICI" 
from all_constraints where owner = 'DCE'
order by table_name, 
decode(constraint_type,'C',1,'P',2,'U',3,'R',4,5),3;
set heading off;
---------------------------------------------------------------------------------------------------	
