---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 04_Sequencies.sql        -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Scripts de Creaci de SEQENCIES i DISPARADORS. 
-- Regles de negoci: garanteix la regla de negogi 1
---------------------------------------------------------------------------------------------------

-- *** ESTATS MEMBRES *** --

CREATE SEQUENCE DCE.EST_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.EST_TRG_IBD
    BEFORE INSERT ON DCE.ESTAT FOR EACH ROW WHEN (NEW.IBD IS NULL)
    BEGIN
        SELECT DCE.EST_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** PAISOS O REGIONS DELS ESTATS MEMBRES *** --

CREATE SEQUENCE DCE.PAI_REG_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.PAI_REG_TRG_IBD 
    BEFORE INSERT ON DCE.PAIS_REGIO FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.PAI_REG_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** PARTITS POLITICS *** --

CREATE SEQUENCE DCE.PAR_POL_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.PAR_POL_TRG_IBD 
    BEFORE INSERT ON DCE.PARTIT_POLITIC FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.PAR_POL_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** FORMES DE PAGAMENT DE LES DESPESES *** --

CREATE SEQUENCE DCE.FOR_PAG_SEQ_IBD START WITH 1 NOCACHE ORDER;

CREATE OR REPLACE TRIGGER DCE.FOR_PAG_TRG_IBD
    BEFORE INSERT ON DCE.FORMA_PAGAMENT FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.FOR_PAG_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** SITUACIONS DE LES DESPESES *** --

CREATE SEQUENCE DCE.SIT_DES_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.SIT_DES_TRG_IBD 
    BEFORE INSERT ON DCE.SITUACIO_DESPESA FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.SIT_DES_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** CATEGORIES DE LES DESPESES GENERALS *** --

CREATE SEQUENCE DCE.CAT_GEN_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.CAT_GEN_TRG_IBD 
    BEFORE INSERT ON DCE.CATEGORIA_GENERAL FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.CAT_GEN_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** CATEGORIES DE LES DESPESES PERSONALS *** --

CREATE SEQUENCE DCE.CAT_PER_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.CAT_PER_TRG_IBD 
    BEFORE INSERT ON DCE.CATEGORIA_PERSONAL FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.CAT_PER_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** CAMBRES PARLAMENTARIES *** --

CREATE SEQUENCE DCE.CAM_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.CAM_TRG_IBD 
    BEFORE INSERT ON DCE.CAMBRA FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.CAM_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

CREATE SEQUENCE DCE.MEM_CAM_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.MEM_CAM_TRG_IBD 
    BEFORE INSERT ON DCE.MEMBRE_CAMBRA FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.MEM_CAM_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** DESPESES *** --

CREATE SEQUENCE DCE.DES_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.DES_TRG_IBD 
    BEFORE INSERT ON DCE.DESPESA FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT DCE.DES_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/
-- *** REGISTRE D'EXECUCIO DE PROCEDIMENTS *** --

CREATE SEQUENCE DCE.LOG_PRO_SEQ_IBD START WITH 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER DCE.LOG_PRO_TRG_IBD 
    BEFORE INSERT ON DCE.LOG_PROCEDIMENT FOR EACH ROW WHEN (NEW.IBD IS NULL) 
    BEGIN
        SELECT LOG_PRO_SEQ_IBD.NEXTVAL INTO :NEW.IBD FROM DUAL;
    END;
/

-- *** CONFIRMAR TRANSACCIONS *** --
COMMIT;
prompt  

select count(*) as "Total", ' SEQNCIES DCE CREADES :' as "Seqncies"
    from all_sequences where sequence_owner = 'DCE';

set heading on;    
select sequence_name as "SEQNCIA" from all_sequences where sequence_owner = 'DCE' order by 1;
set heading off;

select count(*) as "Total", ' DISPARADORS DCE CREATS :' as "Disparadors"
    from all_triggers where owner = 'DCE';
    
set heading on;
select table_name, trigger_name, triggering_event, trigger_type 
    from all_triggers where owner = 'DCE' order by 1,2;
set heading off;
---------------------------------------------------------------------------------------------------