---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 05_Indexs.sql            -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Scripts de Creaci dels INDEXS
---------------------------------------------------------------------------------------------------
  
-- *** CAMBRES PARLAMENTARIES D'ESTATS MEMBRES *** --

CREATE INDEX DCE.CAM_EST_IX_EST ON DCE.CAMBRA_ESTAT (ESTAT ASC) 
    TABLESPACE DCE_INDEXS;

-- *** CAMBRES PARLAMENTARIES DE PAISOS O REGIONS *** --

CREATE INDEX DCE.CAM_PAI_REG_IX_PAI ON DCE.CAMBRA_PAIS_REGIO (PAIS_REGIO ASC) 
    TABLESPACE DCE_INDEXS;

-- *** MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

CREATE INDEX DCE.MEM_CAM_IX_COG_NOM ON DCE.MEMBRE_CAMBRA (COGNOMS ASC, NOM ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.MEM_CAM_IX_PAR ON DCE.MEMBRE_CAMBRA (PARTIT ASC) 
    TABLESPACE DCE_INDEXS;
  
-- *** DESPESES *** --

CREATE INDEX DCE.DES_IX_DAT ON DCE.DESPESA (DATA_DESPESA DESC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_IX_ANY_DAT ON DCE.DESPESA (TO_CHAR(DATA_DESPESA,'YYYY') DESC) 
    TABLESPACE DCE_INDEXS;    
CREATE INDEX DCE.DES_IX_FOR_PAG ON DCE.DESPESA (PAGAMENT ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_IX_SIT_DES ON DCE.DESPESA (SITUACIO ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_IX_IMP ON DCE.DESPESA (IMPORT_BRUT DESC) 
    TABLESPACE DCE_INDEXS;    

-- *** DESPESES GENERALS DE LES CAMBRES PARLAMENTARIES *** --

CREATE INDEX DCE.DES_CAM_IX_CAM ON DCE.DESPESA_CAMBRA (CAMBRA ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_CAM_IX_CAT ON DCE.DESPESA_CAMBRA (CATEGORIA ASC) 
    TABLESPACE DCE_INDEXS;
  
-- *** DESPESES PERSONALS DELS MEMBRES DE LES CAMBRES PARLAMENTARIES *** --

CREATE INDEX DCE.DES_MEM_IX_MEM ON DCE.DESPESA_MEMBRE (MEMBRE ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_MEM_IX_PAR_POL ON DCE.DESPESA_MEMBRE (PARTIT ASC) 
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.DES_MEM_IX_CAT ON DCE.DESPESA_MEMBRE (CATEGORIA ASC) 
    TABLESPACE DCE_INDEXS;

-- *** REGISTRE D'EXECUCI DE PROCEDIMENTS
CREATE INDEX DCE.LOG_PRO_IX_PRO ON DCE.LOG_PROCEDIMENT (PROCEDIMENT ASC)
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.LOG_PRO_IX_DAT ON DCE.LOG_PROCEDIMENT (DATA_HORA ASC)
    TABLESPACE DCE_INDEXS;
CREATE INDEX DCE.LOG_PRO_IX_ERR ON DCE.LOG_PROCEDIMENT (ES_ERROR DESC)
    TABLESPACE DCE_INDEXS;
    
-- *** GRAVAR LES DADES *** --
COMMIT;
prompt  

select count(*) as "Total", ' NDEXS DCE CREATS :' as "ndexs"
    from all_indexes where owner = 'DCE';

set heading on;    
select table_name AS "TAULA", index_name AS "NDEX", tablespace_name as "ESPAI"
from all_indexes where owner='DCE'
order by 1,2;
set heading off;
---------------------------------------------------------------------------------------------------