---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 06_Vistes.sql            -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Creaci de diferents vistes de la Base de Dades.
---------------------------------------------------------------------------------------------------

-- *** PAISOS I REGIONS *** --

CREATE OR REPLACE VIEW DCE.VIS_PAISOS AS
select e.ibd as "Id.Estat", e.estat as "Estat membre", 
    p.ibd as "Id.Pais", p.pais_regio as "Pais o regi"
from estat e inner join pais_regio p on (e.ibd = p.estat)
order by e.estat, p.pais_regio
WITH READ ONLY;

-- *** CAMBRES PARLAMENTRIES *** --

CREATE OR REPLACE VIEW DCE.VIS_CAMBRES AS 
SELECT nvl(e.ibd,p.estat) AS "Id.Estat" , upper(nvl(e.estat,e2.estat)) AS "Estat membre", 
    nvl(p.ibd,0) AS "Id.Pais", upper(nvl(p.pais_regio,' ')) AS "Pais o regi",
    c.ibd AS "Id.Cambra", upper(c.cambra) AS "Cambra parlamentria",
    c.num_membres as "Membres", to_char(c.data_baixa,'dd/mm/yyyy') as "TxBaixa", 
    c.data_baixa as "Baixa"
FROM cambra c LEFT JOIN cambra_estat ce ON (c.ibd = ce.cambra)
    LEFT JOIN estat e ON (ce.estat = e.ibd) 
    LEFT JOIN cambra_pais_regio cp ON (c.ibd = cp.cambra)
    LEFT JOIN pais_regio p ON (cp.pais_regio = p.ibd)
    LEFT JOIN estat e2 ON (p.estat = e2.ibd)
ORDER BY 2,4,6
WITH READ ONLY;

-- *** CAMBRES D'ESTATS *** --

CREATE OR REPLACE VIEW DCE.VIS_CAMBRES_ESTATS AS 
select e.ibd as "Id.Estat" , e.estat as "Estat membre", 
    c.ibd as "Id.Cambra", c.cambra as "Cambra parlamentria",
    to_char(c.data_baixa,'dd/mm/yyyy') as "TxBaixa", c.data_baixa as "Baixa"
from cambra c inner join cambra_estat ce on (c.ibd = ce.cambra)
    inner join estat e on (ce.estat = e.ibd) 
order by e.estat, c.cambra
WITH READ ONLY;

-- *** CAMBRES DE PAISSOS O REGIONS *** --

CREATE OR REPLACE VIEW DCE.VIS_CAMBRES_PAISOS AS 
select  e.ibd as "Id.Estat" , e.estat as "Estat membre",
    p.ibd as "Id.Pais" , p.pais_regio as "Pais o regi", 
    c.ibd as "Id.Cambra", c.cambra as "Cambra parlamentria",
    to_char(c.data_baixa,'dd/mm/yyyy') as "TxBaixa", c.data_baixa as "Baixa"
from cambra c inner join cambra_pais_regio cp on (c.ibd = cp.cambra)
    inner join pais_regio p on (cp.pais_regio = p.ibd)
    inner join estat e on (p.estat = e.ibd)
order by e.estat, p.pais_regio, c.cambra
WITH READ ONLY;

-- *** MEMBRES DE CAMBRES PARLAMENTRIES *** --

CREATE OR REPLACE VIEW DCE.VIS_MEMBRES AS
SELECT M.IBD AS "Id.Membre", upper(M.COGNOMS) AS "Cognoms", upper(M.NOM) AS "Nom", 
    C.IBD AS "Id.Cambra", upper(C.CAMBRA) AS "Cambra parlamentria", M.NUMERO AS "Nm.", 
    P.IBD AS "Id.Partit" , upper(P.PARTIT) AS "Partit poltic",
    to_char(M.DATA_BAIXA,'dd/mm/yyyy') "TxBaixa", M.DATA_BAIXA as "Baixa"
FROM MEMBRE_CAMBRA M INNER JOIN CAMBRA C ON (M.CAMBRA = C.IBD) INNER JOIN
     PARTIT_POLITIC P ON (M.PARTIT = P.IBD)
ORDER BY 2, 3
WITH READ ONLY;

-- *** DESPESES GENERALS DE CAMBRES PARLAMENTRIES *** --

CREATE OR REPLACE VIEW DCE.VIS_DESPESES_CAMBRES AS 
select d.ibd as "Id.Despesa",  c.ibd as "Id.Cambra",  upper(c.cambra) as "Cambra parlamentria",
    c.num_membres as "Membres",
    d.data_despesa as "Data despesa",dc.categoria as "Id.Categoria", cg.codi as "Codi Categoria",
    cg.categoria as "Categoria", d.import_brut as "Import brut", d.tipus_iva as "Tipus IVA",
    d.import_iva as "Import IVA", d.import_net as "Import net", d.pagament as "Id.Pagament", 
    fp.pagament as "Forma pagament", d.situacio as "Id.Situaci", s.situacio as "Situaci", 
    d.descripcio as "Descripci", d.justificacio as "Justificaci",
    to_char(d.data_despesa,'dd/mm/yyyy') "TxData",
    to_number(to_char(d.data_despesa,'yyyy')) "Any"     
from despesa_cambra dc inner join despesa d on (dc.despesa = d.ibd) 
     inner join forma_pagament fp on (d.pagament = fp.ibd) 
     inner join situacio_despesa s on(d.situacio = s.ibd)
     inner join cambra c on (dc.cambra = c.ibd) 
     inner join categoria_general cg on (dc.categoria = cg.ibd) 
order by 2, 4
WITH READ ONLY;

-- *** DESPESES PERSONALS DE MEMBRES DE CAMBRES PARLAMENTRIES *** --

CREATE OR REPLACE VIEW DCE.VIS_DESPESES_MEMBRES AS 
select d.ibd as "Id.Despesa",  c.ibd as "Id.Cambra",   c.cambra as "Cambra parlamentria",
    c.num_membres as "Membres",
    m.ibd as "Id.Membre",  m.numero as "Codi", upper(m.cognoms) as "Cognoms", 
    upper(m.nom) as "Nom", d.data_despesa as "Data despesa", p.ibd as "Id.Partit",
    upper(p.partit) as "Partit poltic", dm.categoria as "Id.Categoria", 
    cp.codi as "Codi Categoria", cp.categoria as "Categoria", d.import_brut as "Import brut", 
    d.tipus_iva as "Tipus IVA", d.import_iva as "Import IVA", d.import_net as "Import net", 
    d.pagament as "Id.Pagament", fp.pagament as "Forma pagament", d.situacio as "Id.Situaci", 
    s.situacio as "Situaci", d.descripcio as "Descripci", d.justificacio as "Justificaci",
    to_char(d.data_despesa,'dd/mm/yyyy') "TxData",
    to_number(to_char(d.data_despesa,'yyyy')) "Any"     
from despesa_membre dm inner join despesa d on (dm.despesa = d.ibd) 
    inner join forma_pagament fp on (d.pagament = fp.ibd) 
    inner join situacio_despesa s on(d.situacio = s.ibd)
    inner join categoria_personal cp on (dm.categoria = cp.ibd) 
    inner join membre_cambra m on (dm.membre = m.ibd) 
    inner join cambra c on (m.cambra = c.ibd)
    inner join partit_politic p on (m.partit = p.ibd) 
order by  2,4,8
WITH READ ONLY;

-- *** TOTES LES DESPESES *** --

CREATE OR REPLACE VIEW DCE.VIS_DESPESES AS 
select d.ibd as "Id.Despesa",  nvl(c.ibd,c2.ibd) as "Id.Cambra",   
    nvl(c.cambra, c2.cambra) as "Cambra parlamentria",
    nvl(c.num_membres,c2.num_membres) as "Membres",
    nvl(m.ibd,0) as "Id.Membre",  nvl(m.numero,0) as "Nmero", 
    nvl(upper(m.cognoms),' ') as "Cognoms", nvl(upper(m.nom),' ') as "Nom", 
    d.data_despesa as "Data despesa", nvl(p.ibd,0) as "Id.Partit",
    nvl(upper(p.partit),' ') as "Partit poltic", nvl(cg.ibd,cp.ibd) as "Id.Categoria", 
    nvl(cg.categoria,cp.categoria) as "Categoria", 
    nvl(cg.codi,cp.codi) as "Codi Categoria",
    d.import_brut as "Import brut", 
    d.tipus_iva as "Tipus IVA", d.import_iva as "Import IVA", d.import_net as "Import net",
    d.pagament as "Id.Pagament", fp.pagament as "Forma pagament", d.situacio as "Id.Situaci", 
    s.situacio as "Situaci", d.descripcio as "Descripci", d.justificacio as "Justificaci",
    to_char(d.data_despesa,'dd/mm/yyyy') "TxData",
    to_number(to_char(d.data_despesa,'yyyy')) "Any"
from despesa d 
   left join despesa_membre dm on (d.ibd = dm.despesa)
   left join despesa_cambra dc on (d.ibd = dc.despesa)
   left join forma_pagament fp on (d.pagament = fp.ibd) 
   left join situacio_despesa s on(d.situacio = s.ibd)
   left join categoria_general cg on (dc.categoria = cg.ibd) 
   left join categoria_personal cp on (dm.categoria = cp.ibd)
   left join membre_cambra m on (dm.membre = m.ibd) 
   left join partit_politic p on (m.partit = p.ibd)
   left join cambra c on (m.cambra = c.ibd)
   left join cambra c2 on (dc.cambra = c2.ibd)
order by  2,5,8
WITH READ ONLY;

-- *** CONFIRMAR TRANSACCIONS *** --
COMMIT;
prompt  

select count(*) AS "Total",' VISTES DPE CREADES : ' AS "Vistes" 
    from all_views where owner = 'DCE';

set heading on;
select view_name as "VISTA" from all_views where owner='DCE' order by 1;
set heading off;
---------------------------------------------------------------------------------------------------