---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 12_Ins01_Cambres.sql         -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013                   -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Inserci de dades en les taules CAMBRA, CAMBRA_ESTAT I CAMBRA_PAIS_REGIO mitjanant els 
--         procediments CAMBRA_A, CAMBRA_ESTAT_A i CAMBRA_PAIS_REGIO_A del package ABM
---------------------------------------------------------------------------------------------------

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
BEGIN

proces := 'NOVA CAMBRA PARLAMENTRIA: ';
/*-------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
   i_nom     IN  CAMBRA.CAMBRA%TYPE,  -- Nom de la cambra
   i_adreca  IN  CAMBRA.ADRECA%TYPE,  -- Adrea postal de la cambra
   i_ciutat  IN  CAMBRA.CIUTAT%TYPE,  -- Ciutat on es troba la cambra
   i_telefon IN  CAMBRA.TELEFON%TYPE, -- Telfon de contacte de la cambra
   i_llocWeb IN  CAMBRA.LLOC_WEB%TYPE,-- Adrea URL del lloc web de la cambra (opcional '' o null) 
   i_estat   IN  ESTAT.IBD%TYPE,      -- Identificador del estat membre (0 si s de pais o regi)
   i_pais    IN  PAIS_REGIO.IBD%TYPE, -- Identificador del pais o regi (0 si s d'estat membre)
   o_rsp     OUT VARCHAR2             -- Resultat de l'execuci del procediment 
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats que no sn opcionals estiguin informats
   - Si tant <i_estat> com <i_pais>, sn tots dos a la vegada = 0  b > 0, es tracta com un error,
     ja que una cambra o b ho s d'un estat membre o b d'un pais o regi. 
   - L'existncia d'una cambra amb el mateix nom.
   - Si <i_estat> > 0 crida al procediment CAMBRA_ESTAT_A que fa l'alta en la taula CAMBRA_ESTAT
   - Si <i_pais> > 0 crida al procediment CAMBRA_PAIS_REGIO_A i fa l'alta en la taula 
     CAMBRA_PAIS_REGIO
   - Regles de negoci 3 i 4: L'existncia del estat membre o del pais/regi i del nmero de 
     cambres d'alta que tenen, que com a mxim s 1 per pais o regi i 2 per estat membre. 
   - Regla de negoci 12: L'execuci del procediment es registra en la taula LOG_PROCEDIMENT.
----------------------------------------------------------------------------------------------------
*/
-- INSERCIONS CORRECTES:

dce.abm.cambra_a('AUSTRIAN NATIONAL COUNCIL', 'DR. KARL RENNER-RING 3', '1017 WIEN', '(43) 140110-0', 
    'www.parlament.gv.at', 1, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CHAMBRE DES REPRSENTANTS DE BELGIQUE', 'RUE DE LOUVAIN 21', '1008 BRUXELLES', 
    '(02) 5498111', 'www.lachambre.be', 2, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 
    'www.sabor.hr', 4, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('DANISH PARLIAMENT', 'FOLKETINGET, CHRISTIANSBORG', '1240 COPENHAGEN K', 
    '(45) 33375500', 'www.ft.dk', 7, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('ASSEMBLE NATIONALE FRANAISE', '126 RUE DE L''UNIVERSIT', '75355 PARIS 07 SP', 
    '(33) 0140636000', 'www.assemblee-nationale.fr', 10, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('GERMAN BUNDESTAG', 'PLATZ DER REPUBLIK 1', '11011 BERLIN', '(49) 30227-0', 
    'www.bundestag.de', 11, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CORTES GENERALES-CONGRESO DE LOS DIPUTADOS', 'C/FLORIDABLANCA S/N', '28071 MADRID', 
    '(34) 913906000', 'www.congreso.es', 25, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CORTES GENERALES-SENADO', 'C/ BAILN, 3', '28071 MADRID', '(34) 900103038', 
    'www.senado.es', 25, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('PARLAMENTO DE ANDALUCA', 'C/ SAN JUAN DE RIBERA, S/N', '41009 SEVILLA', 
    '(34) 954592100', 'www.parlamentodeandalucia.es', 0, 1, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('PARLAMENT DE CATALUNYA', 'PARC DE LA CIUTADELLA, S/N', '08003 BARCELONA', 
    '(34) 933046500', 'www.parlament.cat', 0, 8, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('EUSKO LEGEBILTZARRA-PARLAMENTO VASCO', 'BECERRO DE BENGOA', 
    '01005 VITORIA - GASTEIZ', '(34) 945004000', 'www.parlamentovasco.euskolegebiltzarra.org', 
    0, 10, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('ASAMBLEA DE MADRID', 'PL/ DE LA ASAMBLEA DE MADRID, 1', '28018 MADRID', 
    '(34) 9177 9500', 'www.asambleamadrid.es', 0, 14, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('PARLAMENT DE SES ILLES BALEARS', 'C/ CONQUERIDOR, 11 ', 'PALMA DE MALLORCA', 
    '(34) 971228281', 'www.parlamentib.es', 0, 3, rsp);
dbms_output.put_line(proces || rsp);

-- INSERCIONS AMB ERRORS:

-- Falten parmetres obligatoris

dce.abm.cambra_a('', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 'www.sabor.hr', 
    4, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CROATIAN PARLIAMENT', '', '10 000 ZAGREB', '(385) 14569222', 'www.sabor.hr', 
    4, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '', '(385) 14569222', 'www.sabor.hr', 
    4, 0, rsp);
dbms_output.put_line(proces || rsp);

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '', 'www.sabor.hr', 
    4, 0, rsp);
dbms_output.put_line(proces || rsp);

-- No s'indiquen ni estat membre ni pais o regi

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 
    'www.sabor.hr', 0, 0, rsp);
dbms_output.put_line(proces || rsp);

-- S'indiquen tant estat membre com pais o regi

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 
    'www.sabor.hr', 4, 3, rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un estat inexistent

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 
    'www.sabor.hr', 74, 0, rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un estat que ja t dues cambres d'alta

dce.abm.cambra_a('CONGRESO DE LOS DIPUTADOS', 'C/FLORIDABLANCA S/N', '28071 MADRID', 
    '(34) 913906000', 'www.congreso.es', 25, 0, rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un pais o regi inexistent

dce.abm.cambra_a('CROATIAN PARLIAMENT', 'TRG SV. MARKA 6', '10 000 ZAGREB', '(385) 14569222', 
    'www.sabor.hr', 0, 93, rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un pais o regi que ja t una cambra d'alta

dce.abm.cambra_a('CATALUNYA PARLIAMENT', 'PARC DE LA CIUTADELLA, S/N', '08003 BARCELONA', 
    '(34) 933046500', 'www.parlament.cat', 0, 8, rsp);
dbms_output.put_line(proces || rsp);


END;
/
