---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 12_Ins02_Membres.sql         -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013                   -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Inserci de dades en la taula MEMBRE_CAMBRA mitjanant el procediment MEMBRE_A 
--         del package ABM
-- El resultat de l'exeuci dels procediments es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
BEGIN

proces := 'NOU MEMBRE DE CAMBRA PARLAMENTRIA: ';
/*-------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
   i_codi    IN  VARCHAR2 (12), -- Codi identificador (NIF, etc.)
   i_nom     IN  VARCHAR2 (20), -- Nom del membre de la cambra
   i_cognoms IN  VARCHAR2 (50), -- Cognoms del membre de la cambra
   i_telefon IN  VARCHAR2 (20), -- Telfon del membre de la cambra
   i_email   IN  VARCHAR2 (50), -- Adrea elctrnica del membre de la cambra
   i_partit  IN  NUMBER (3),    -- Identificador bbdd del partit al que pertany
   i_cambra  IN  NUMBER (3),    -- Identificador bbdd de la cambra a la que pertany
   i_numero  IN  NUMBER (3),    -- Nmero identificador dins de la cambra
   o_rsp     OUT VARCHAR2       -- Resultat de l'execuci del procediment 
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que existeixi el membre de la cambra.
   - Regla de negoci 5: Baixa/alta lgica d'un membre d'una cambra parlamentria en la taula 
     MEMBRE_CAMBRA mitjanant una data de baixa que deixa el membre de la cambra inactiu/actiu.
   - Regla de negoci 5 i 7: Si es passa una data s'actualitza la data de baixa, el membre de la 
     cambra queda inactiu, i es decrementa el comptador de nmero de membres de la cambra 
     parlamentria a la que pertany. Si no es passa cap data, si el membre est de baixa, es treu
     la data de baixa, el membre torna a estar actiu, i s'incrementa el comptador de nmero de 
     membres de la cambra parlamentria a la que pertany.
   - Regla de negoci 12: L'execuci del procediment es registra en la taula log_Procediment.
---------------------------------------------------------------------------------------------------
*/

-- INSERCIONS CORRECTES:

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34) 933046500',
    'jordi.turull@parlament.cat',3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFJUNQUERAS','ORIOL','JUNQUERAS I VIES','(34) 933046500',
    'oriol.junqueras@parlament.cat',12,10,54,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFNAVARRRO','PERE','NAVARRO I MORERA','(34) 933046500',
    'pere.navarro@parlament.cat',4,10,75,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFSANCHEZ','Alicia','SNCHEZ-CAMACHO I PREZ','(34) 933046500',
    'alicia.sanchezcamacho@parlament.cat',1,10,106,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFHERRERA','JOAN','HERRERA TORRES','(34) 933046500',
    'JOAN.HERRERA@parlament.cat',22,10,52,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFRIVERA','ALBERT','RIVERA DAZ','(34) 933046500',
    'albert.rivera@parlament.cat',23,10,93,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFMAJBAUZA','Maria Jos','Bauza i Alonso','(34) 971228281',
    'mariajose.bauza@parlamentib.es',1,13,1,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34) 933046500',
    'jordi.turull@parlament.cat',3,7,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFJUNQUERAS','ORIOL','JUNQUERAS I VIES','(34) 933046500',
    'oriol.junqueras@parlament.cat',12,7,54,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFNAVARRRO','PERE','NAVARRO I MORERA','(34) 933046500',
    'pere.navarro@parlament.cat',4,7,75,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFSANCHEZ','Alicia','SNCHEZ-CAMACHO I PREZ','(34) 933046500',
    'alicia.sanchezcamacho@parlament.cat',1,7,106,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFHERRERA','JOAN','HERRERA TORRES','(34) 933046500',
    'JOAN.HERRERA@parlament.cat',22,7,52,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFRIVERA','ALBERT','RIVERA DAZ','(34) 933046500',
    'albert.rivera@parlament.cat',23,7,93,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFJLBAUZA','Jos Luis','Bauza i Alonso','(34) 971228281',
    'joseluis.bauza@parlamentib.es',1,13,2,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFJMOREY','Jaime','Morey i Soley','(34) 971228281',
    'jaime.morey@parlamentib.es',1,13,3,rsp);
dbms_output.put_line(proces || rsp);

-- INSERCIONS INCORRECTES:

-- Falten parmetres obligatoris
dce.abm.membre_a('','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','','(34)933046500','jordi.turull@parlament.cat',3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','','jordi.turul@parlament.cat',3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','',3,10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    '',10,116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,'',116,rsp);
dbms_output.put_line(proces || rsp);

dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,10,'',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una cambra parlamentria inexistent
dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,99,116,rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un nmero de membre de cambra ja existent
dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    3,10,116,rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un partit poltic inexistent
dce.abm.membre_a('NIFTURULL','Jordi','Turull i Negre','(34)933046500','jordi.turull@parlament.cat',
    377,10,117,rsp);
dbms_output.put_line(proces || rsp);
 
---------------------------------------------------------------------------------------------------
END;
/
