---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 12_Ins03_Despeses_Gen.sql    -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013                   -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Inserci de dades en la taules DESPESA i DESPESA_CAMBRA mitjanant el procediment 
--         DESPESA_CAMBRA_A del package ABM
-- El resultat de l'exeuci dels procediments es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
BEGIN

proces := 'NOVA DESPESA GENERAL DE CAMBRA PARLAMENTRIA: ';
/*-------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_data         IN  DESPESA.DATA_DESPESA%TYPE,     -- Data de la despesa
    i_cambra       IN  DESPESA_CAMBRA.CAMBRA%TYPE,    -- Identificador bbdd de la cambra
    i_categoria    IN  DESPESA_CAMBRA.CATEGORIA%TYPE, -- Categoria de la despesa
    i_import       IN  DESPESA.IMPORT_BRUT%TYPE,      -- Import brut de la despesa
    i_tipusIva     IN  DESPESA.TIPUS_IVA%TYPE,        -- Tipus d'IVA de la  despesa
    i_descripcio   IN  DESPESA.DESCRIPCIO%TYPE,       -- Descripci de la despesa
    i_justificacio IN  DESPESA.JUSTIFICACIO%TYPE,     -- Justificaci de la despesa
    i_pagament     IN  DESPESA.PAGAMENT%TYPE,         -- Forma de pagament de la despesa
    i_situacio     IN  DESPESA.SITUACIO%TYPE,         -- Situaci de la despesa
    i_proveidor    IN  DESPESA.PROVEIDOR%TYPE,        -- Provedor 
    i_escaneig     IN  DESPESA.URL_ESCANEIG%TYPE,     -- URL amb la informaci escanejada
    o_rsp          OUT VARCHAR2                       -- Resultat de l'execuci del procediment 
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria
   - L'existncia de la categoria general
   - L'existncia de la forma de pagament
   - L'existncia de la situaci de despesa
   - Regla de negoci 2: Que el provedor estigui informat si la despesa > 30 euros.
   - Regla de negoci 8: El clcul del import del IVA i del import net es fa a nivell de valors 
     automtics de les columnes de la base de dades. El import i el tipus d'IVA han de ser > 0
   - Regla de negoci 9: No es pot entrar despeses en cambres donades de baixa si la data de 
     despesa s superior a la de baixa.
   - Regla de negoci 11: Actualitza les dades en les taules estadstiques
   - Regla de negoci 12: L'execuci del procediment es registra en la taula LOG_PROCEDIMENT.
---------------------------------------------------------------------------------------------------
*/
-- INSERCIONS CORRECTES:

-- 2009
dce.abm.despesa_cambra_a('10/10/2009',10,1,250,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor1','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',10,2,25,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',10,3,1250,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',10,4,253.45,18,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',10,5,125,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',10,1,350,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2009',7,2,1150,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',7,3,25,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',7,4,1250,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',7,5,253.45,18,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',7,1,125,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',7,2,350,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2009',13,1,850,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',13,2,1150,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',13,3,25,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',13,4,1250,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',13,5,253.45,18,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2009',13,1,850,18,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2010
dce.abm.despesa_cambra_a('10/10/2010',10,1,250,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor1','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',10,2,25,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',10,3,1250,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',10,4,253.45,19,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',10,5,125,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',10,1,350,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2010',7,2,1150,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',7,3,25,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',7,4,1250,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',7,5,253.45,19,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',7,1,125,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',7,2,350,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2010',13,1,850,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',13,2,1150,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',13,3,25,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',13,4,1250,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',13,5,253.45,19,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2010',13,1,850,19,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2011
dce.abm.despesa_cambra_a('10/10/2011',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor1','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',10,2,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',10,3,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',10,4,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',10,5,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',10,1,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2011',7,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',7,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',7,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',7,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',7,1,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',7,2,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2011',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',13,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',13,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',13,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2011',13,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dce.abm.despesa_cambra_a('10/10/2011',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2012
dce.abm.despesa_cambra_a('10/10/2012',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor1','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',10,2,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',10,3,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',10,4,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',10,5,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',10,1,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2012',7,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',7,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',7,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',7,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',7,1,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',7,2,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2012',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',13,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',13,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',13,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',13,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2012',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2013
dce.abm.despesa_cambra_a('10/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor1','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',10,2,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',10,3,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',10,4,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',10,5,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',10,1,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2013',7,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',7,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',7,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',7,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',7,1,125,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',7,2,350,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('10/10/2013',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',13,2,1150,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',13,3,25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',13,4,1250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',13,5,253.45,21,'Descripci de la despesa fins a 50 carac',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('10/10/2013',13,1,850,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);


-- INSERCIONS INCORRECTES:

-- No s'indiquen parmetres obligatoris
dce.abm.despesa_cambra_a('',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013','',1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,'',250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,'',21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,250,'','Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,250,21,'',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    '',1,2,'','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters','',2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('11/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,'','proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una cambra parlamentria inexistent
dce.abm.despesa_cambra_a('12/10/2013',98,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

-- S'inidica una categoria general inexistent
dce.abm.despesa_cambra_a('12/10/2013',10,31,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una forma de pagament inexistent
dce.abm.despesa_cambra_a('12/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',15,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una situaci inexistent
dce.abm.despesa_cambra_a('12/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,91,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una despesa > 30 euros i no s'indica el provedor
dce.abm.despesa_cambra_a('12/10/2013',10,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un import zero o menor de zero
dce.abm.despesa_cambra_a('12/10/2013',98,1,0,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,'1','','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_cambra_a('12/10/2013',98,1,-25,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,'1','','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica un tipus d'IVA zero o menor de zero
dce.abm.despesa_cambra_a('12/10/2013',98,1,250,0,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,'1','','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_cambra_a('12/10/2013',98,1,250,-21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins a 50 caracters',1,'1','','',rsp);
dbms_output.put_line(proces || rsp);

-- S'indica una data de despesa superior a la data de baixa d'una cambra que ho est
-- Aquesta prova es posa en el script 14_Mod_Taules.sql que s'executa desprs del 13_Del_Taules.sql
--dce.abm.despesa_cambra_a('02/11/2013',7,1,25,21,'Descripci de la despesa fins a 50 caracters',
--    'Justificaci de la despesa fins a 50 caracters',1,2,'','',rsp);
--dbms_output.put_line(proces || rsp);    
---------------------------------------------------------------------------------------------------
END;
/
