---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 12_Ins04_Despeses_Per.sql    -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 11/11/2013                   -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
-- Funci: Inserci de dades en la taules DESPESA i DESPESA_MEMBRE mitjanant el procediment 
--         DESPESA_MEMBRE_A del package ABM
-- El resultat de l'exeuci dels procediments es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
BEGIN

proces := 'NOVA DESPESA PERSONAL DE MEMBRE DE CAMBRA PARLAMENTRIA: ';
/*-------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_data         IN  DESPESA.DATA_DESPESA%TYPE,     -- Data de la despesa
    i_membre       IN  DESPESA_MEMBRE.MEMBRE%TYPE,    -- Identificador bbdd del membre
    i_categoria    IN  DESPESA_MEMBRE.CATEGORIA%TYPE, -- Categoria de la despesa
    i_import       IN  DESPESA.IMPORT_BRUT%TYPE,      -- Import brut de la despesa
    i_tipusIva     IN  DESPESA.TIPUS_IVA%TYPE,        -- Tipus d'IVA de la  despesa
    i_descripcio   IN  DESPESA.DESCRIPCIO%TYPE,       -- Descripci de la despesa
    i_justificacio IN  DESPESA.JUSTIFICACIO%TYPE,     -- Justificaci de la despesa
    i_pagament     IN  DESPESA.PAGAMENT%TYPE,         -- Forma de pagament de la despesa
    i_situacio     IN  DESPESA.SITUACIO%TYPE,         -- Situaci de la despesa
    i_proveidor    IN  DESPESA.PROVEIDOR%TYPE,        -- Provedor 
    i_escaneig     IN  DESPESA.URL_ESCANEIG%TYPE,     -- URL amb la informaci escanejada
    o_rsp          OUT VARCHAR2                       -- Resultat de l'execuci del procediment 
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia del membre de la cambra parlamentria
   - L'obtenci del partit poltic del membre en el moment d'emmagatzemar la despesa
   - L'existncia de la categoria personal
   - L'existncia de la forma de pagament
   - L'existncia de la situaci de despesa
   - Regla de negoci 2: El clcul del import del IVA i del import net es fa a nivell de valors 
     automtics de les columnes de la base de dades. El import i el tipus d'IVA han de ser > 0
   - Regla de negoci 8; Que el provedor estigui informat si la despesa > 30 euros.
   - Regla de negoci 10: No es pot entrar despeses en membres donats de baixa si la data de 
     despesa s superior a la de baixa.
   - Regla de negoci 11: Actualitza les dades en les taules estadstiques
   - Regla de negoci 12: L'execuci del procediment es registra en la taula log_Procediment.
---------------------------------------------------------------------------------------------------
*/
-- INSERCIONS CORRECTES

-- 2009
dce.abm.despesa_membre_a('10/10/2009',1,2,1250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',2,3,15,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',3,5,3250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',4,8,1253.45,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',5,2,255,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',6,3,350,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',7,5,250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2009',1,8,2250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',2,2,25,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',3,3,1250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',4,5,5253.45,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',5,8,955,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',6,2,1350,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',7,3,550,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/10/2009',8,2,250.04,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',9,3,25.77,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',10,5,250.65,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',11,8,11253.45,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',12,2,855.54,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',13,3,850.33,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2009',14,5,1250.97,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2009',8,8,1250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',9,2,19,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',10,3,3250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',11,5,1253.45,18,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',12,8,255,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',13,2,350,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2009',14,3,250,18,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2010
dce.abm.despesa_membre_a('10/10/2010',1,2,1250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',2,3,25.66,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',3,5,3250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',4,8,1253.45,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',5,2,255,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',6,3,350,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',7,5,250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2010',1,8,2250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',2,2,25,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',3,3,1250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',4,5,5253.45,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',5,8,955,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',6,2,1350,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',7,3,550,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/10/2010',8,2,250.04,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',9,3,15.77,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',10,5,250.65,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',11,8,11253.45,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',12,2,855.54,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',13,3,850.33,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2010',14,5,1250.97,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2010',8,8,1250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',9,2,27,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',10,3,3250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',11,5,1253.45,19,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',12,8,255,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',13,2,350,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2010',14,3,250,19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2011
dce.abm.despesa_membre_a('10/10/2011',1,2,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',2,3,29,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',3,5,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',4,8,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',5,2,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',6,3,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',7,5,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2011',1,8,2250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',2,2,30,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',3,3,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',4,5,5253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',5,8,955,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',6,2,1350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',7,3,550,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/10/2011',8,2,250.04,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',9,3,5.77,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',10,5,250.65,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',11,8,11253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',12,2,855.54,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',13,3,850.33,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2011',14,5,1250.97,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2011',8,8,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',9,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',10,3,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',11,5,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',12,8,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',13,2,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2011',14,3,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2012
dce.abm.despesa_membre_a('10/10/2012',1,2,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',2,3,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',3,5,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',4,8,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',5,2,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',6,3,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',7,5,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2012',1,8,2250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',2,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',3,3,8250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',4,5,253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',5,8,1255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',6,2,550,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',7,3,950,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/10/2012',8,2,250.35,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',9,3,25.44,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',10,5,250.99,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',11,8,3253.45,21,'Descripci de la despesa fins a 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',12,2,1255.54,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',13,3,950.28,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2012',14,5,2250.84,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2012',8,8,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',9,2,15,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',10,3,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',11,5,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',12,8,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',13,2,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2012',14,3,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- 2013
dce.abm.despesa_membre_a('10/10/2013',1,2,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',2,3,12,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',3,5,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',4,8,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',5,2,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',6,3,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',7,5,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2013',1,8,11250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',2,2,22,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',3,3,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',4,5,953.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',5,8,1255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',6,2,1350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',7,3,550,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/10/2013',8,2,2250.35,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',9,3,25.88,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',10,5,1250.25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',11,8,753.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',12,2,1255.95,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',13,3,1350.22,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/10/2013',14,5,550.44,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

dce.abm.despesa_membre_a('10/11/2013',8,8,1250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',9,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',10,3,3250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,4,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',11,5,1253.45,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',12,8,255,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',2,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',13,2,350,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,3,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);
dce.abm.despesa_membre_a('10/11/2013',14,3,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,4,'proveidor02','',rsp);
dbms_output.put_line(proces || rsp);

-- INSERCIONS INCORRECTES

-- No s'indiquen parmetres obligatoris
dce.abm.despesa_membre_a('',1,2,250,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013','',2,250,21,'Descripci de la despesa fins a 50 caracte',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,'',250,21,'Descripci de la despesa fins a 50 caracte',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,'',21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,250,'','Descripci de la despesa fins a 50 caracte',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,250,21,'',
    'Justificaci de la despesa fins 50 caracters',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,250,21,'Descripci de la despesa fins a 50 caract',
    '',1,2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters','',2,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

dce.abm.despesa_membre_a('10/10/2013',1,2,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,'','proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica un membre de cambra parlamentria inexistent
dce.abm.despesa_membre_a('11/10/2013',98,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'inidica una categoria personal inexistent
dce.abm.despesa_membre_a('11/10/2013',2,98,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica una forma de pagament inexistent
dce.abm.despesa_membre_a('11/10/2013',2,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',98,1,'','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica una situaci inexistent
dce.abm.despesa_membre_a('11/10/2013',2,2,25,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,98,'','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica una despesa > 30 euros i no s'indica el provedor
dce.abm.despesa_membre_a('02/10/2013',3,1,250,21,'Descripci de la despesa fins a 50 caract',
    'Justificaci de la despesa fins 50 caracters',1,2,'','',rsp);
dbms_output.put_line(proces || rsp);    

-- S'indica un import zero o menor de zero
dce.abm.despesa_membre_a('11/10/2013',1,2,0,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);  
dce.abm.despesa_membre_a('11/10/2013',1,2,-23,21,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica un tipus d'IVA zero o menor de zero
dce.abm.despesa_membre_a('11/10/2013',1,2,125,0,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  
dce.abm.despesa_membre_a('11/10/2013',1,2,125,-19,'Descripci de la despesa fins 50 caracters',
    'Justificaci de la despesa fins 50 caracters',1,1,'proveidor01','',rsp);
dbms_output.put_line(proces || rsp);  

-- S'indica una data de despesa superior a la data de baixa d'un membre que ho est
-- Aquesta prova es posa en el script 14_Mod_Taules.sql que s'executa desprs del 13_Del_Taules.sql
--dce.abm.despesa_membre_a('02/11/2013',3,1,25,21,'Descripci de la despesa fins a 50 caract',
--    'Justificaci de la despesa fins 50 caracters',1,2,'','',rsp);
--dbms_output.put_line(proces || rsp);    
---------------------------------------------------------------------------------------------------
END;
/
