---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_01.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donada una cambra parlamentria, un any i un membre de la cambra, llista totes les 
   despeses associades al membre de la cambra en aquell any.
   Ordenat de forma descendent pel valor de cada despesa.
 * Executa el procediment DESPESES_01 del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_cambra        IN  NUMBER,    -- Identificador bbdd de la cambra parlamentria
    i_membre        IN  NUMBER,    -- Nmero de membre en la cambra
    i_any           IN  NUMBER,    -- Any de les despeses en format yyyy
    o_rsp          OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria
   - L'existncia del nmero de membre en la cambra indicada
-------------------------------------------------------------------------------------------------*/

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_01 ';

-- EXECUCIONS CORRECTES:
dce.con.despeses_01(10,75,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,116,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,106,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,52,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,93,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,54,2009,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_01(10,75,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,116,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,106,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,52,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,93,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,54,2010,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_01(10,75,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,116,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,106,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,52,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,93,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,54,2011,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_01(10,75,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,116,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,106,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,52,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,93,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,54,2012,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_01(10,75,2013,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,116,2013,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,106,2013,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,52,2013,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,93,2013,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_01(10,54,2013,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_cambra
dce.con.despeses_01('',75,2013,rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_membre
dce.con.despeses_01(10,'',2013,rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_any
dce.con.despeses_01(10,75,'',rsp); dbms_output.put_line(proces || rsp);

-- Cambra inexistent
dce.con.despeses_01(98,75,2013,rsp); dbms_output.put_line(proces || rsp);

-- Nmero de membre inexistent
dce.con.despeses_01(10,795,2013,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
