---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_02.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donada una cambra parlamentria i un any, el llistat dels seus membres amb la despesa 
   directa que ha fet cadascun, incloent:
      - El seu nom i cognoms
      - Partit poltic actual
      - Suma de totes les seves despeses directes associades
   Ordenat de forma descendent pel valor de la suma de les despeses.
 * Executa el procediment DESPESES_02 del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_cambra        IN  NUMBER,    -- Identificador bbdd de la cambra parlamentria
    i_any           IN  NUMBER,    -- Any de les despeses en format yyyy
    o_rsp          OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria
-------------------------------------------------------------------------------------------------*/
SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_02 ';

-- EXECUCIONS CORRECTES:
dce.con.despeses_02(7,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(7,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(7,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(7,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(7,2013,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_02(10,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(10,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(10,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(10,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(10,2013,rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_02(13,2009,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(13,2010,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(13,2011,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(13,2012,rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_02(13,2013,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_cambra
dce.con.despeses_02('',2013,rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_any
dce.con.despeses_02(10,'',rsp); dbms_output.put_line(proces || rsp);

-- Cambra inexistent
dce.con.despeses_02(98,2013,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
