---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_03.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donat un any, el llistat de la despesa total de totes les cambres parlament., incloent:
    - Nom de la cambra parlamentria
    - Nombre de membres de la cambra
    - Despesa mitja dels seus membres (tenint en compte noms les despeses directes realitzades
      pels membres de la cambra).
    - Suma de les despeses totals associades als membres de la cambra.
    - Suma de les despeses totals associades a la cambra parlamentria (s a dir les que no estan
      associades a un membre concret).
    - Suma de totes les despeses.
 * Executa el procediment DESPESES_03 del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_any          IN  NUMBER,    -- Any de les despeses
    i_iva          IN  CHAR,      -- Imports amb IVA o sense: S=Amb IVA, N=Sense IVA
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
-------------------------------------------------------------------------------------------------*/
SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_03 ';

-- EXECUCIONS CORRECTES:

dce.con.despeses_03(2009,'N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2010,'N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2011,'N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2012,'N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2013,'N',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_03(2009,'S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2010,'S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2011,'S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2012,'S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_03(2013,'S',rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_any
dce.con.despeses_03('','N',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_IVA
dce.con.despeses_03(2013,'',rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
