---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_04.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donat un any i una cambra parlamentria, el llistat de la despesa segmentada per 
   categories de despesa, s a dir, un llistat que retorni les columnes segents:
     - Codi de la categoria de despesa.
     - Descripci de la categoria de despesa.
     - Suma de les despeses totals associades a la categoria de despesa, 
       durant lany indicat i en la cambra parlamentria indicada.
   Ordenat de forma descendent pel valor de la suma de les despeses.
 * Executa el procediment DESPESES_04 del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_cambra       IN  NUMBER,    -- Identificador bbdd de la cambra parlamentria
    i_any          IN  NUMBER,    -- Any de les despeses en format yyyy
    i_tipus        IN  CHAR,      -- Tipus de despeses: G=Generals, P=Personals, T=Totes
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria
-------------------------------------------------------------------------------------------------*/
SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_04 ';

-- EXECUCIONS CORRECTES:
dce.con.despeses_04(7,2009,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2009,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2009,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2009,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2009,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2009,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2009,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2009,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2009,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_04(7,2010,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2010,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2010,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2010,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2010,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2010,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2010,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2010,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2010,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_04(7,2011,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2011,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2011,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2011,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2011,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2011,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2011,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2011,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2011,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_04(7,2012,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2012,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2012,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2012,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2012,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2012,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2012,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2012,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2012,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_04(7,2013,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2013,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(7,2013,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2013,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2013,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(10,2013,'t',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2013,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2013,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_04(13,2013,'t',rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_cambra
dce.con.despeses_04('',2013,'t',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_any
dce.con.despeses_04(10,'','t',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_tipus
dce.con.despeses_04(10,2013,'',rsp); dbms_output.put_line(proces || rsp);

-- Tipus de despesa <> G,P,T
dce.con.despeses_04(10,2013,'D',rsp); dbms_output.put_line(proces || rsp);

-- Cambra inexistent
dce.con.despeses_04(98,2013,'t',rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
