---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_06.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donat un any, el llistat de totes les cambres amb el seu estat comptable,incloent:
     - Nom de la cambra parlamentria
     - Nombre de membres de la cambra
     - Suma de totes les despeses pendents daprovaci.
     - Suma de totes les despeses aprovades.
     - Suma de totes les despeses pendents dabonament.
     - Suma de totes les despeses abonades.
 * Executa el procediment DESPESES_06 del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_any          IN  NUMBER,    -- Any de les despeses
    i_tipus        IN  CHAR,      -- Tipus de despeses: G=Generals, P=Personals, T=Totes
    i_iva          IN  CHAR,      -- Imports amb IVA o sense: S=Amb IVA, N=Sense IVA
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
-------------------------------------------------------------------------------------------------*/
SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_06 ';

-- EXECUCIONS CORRECTES:

dce.con.despeses_06(2009,'g','N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2009,'p','N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2009,'t','N',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06(2010,'g','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2010,'p','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2010,'t','S',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06(2011,'g','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2011,'p','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2011,'t','S',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06(2012,'g','N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2012,'p','N',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2012,'t','N',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06(2013,'g','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2013,'p','S',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06(2013,'t','S',rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_any
dce.con.despeses_06('','t','S',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_tipus
dce.con.despeses_06(2013,'','S',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_IVA
dce.con.despeses_06(2013,'T','',rsp); dbms_output.put_line(proces || rsp);

-- Tipus de despesa <> G,P,T
dce.con.despeses_06(2013,'D','S',rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
