---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Despeses_06b.sql  -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 13/11/2013               -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Funci: Donat un any, el llistat de totes les cambres parlamentries amb el seu estat comptable 
   categoritzat,incloent:
     - Nom de la cambra parlamentria
     - Situaci comptable
     - Suma de les despeses totals associades de cada situaci comptable de cada cambra durant 
       lany indicat
 * Executa el procediment DESPESES_06b del package CON
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_any          IN  NUMBER,    -- Any de les despeses
    i_tipus        IN  CHAR,      -- Tipus de despeses: G=Generals, P=Personals, T=Totes
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment de la consulta
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
-------------------------------------------------------------------------------------------------*/
SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'DESPESES_06b ';

-- EXECUCIONS CORRECTES:

dce.con.despeses_06b(2009,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2009,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2009,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06b(2010,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2010,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2010,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06b(2011,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2011,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2011,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06b(2012,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2012,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2012,'t',rsp); dbms_output.put_line(proces || rsp);

dce.con.despeses_06b(2013,'g',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2013,'p',rsp); dbms_output.put_line(proces || rsp);
dce.con.despeses_06b(2013,'t',rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_any
dce.con.despeses_06b('','t',rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_tipus
dce.con.despeses_06b(2013,'',rsp); dbms_output.put_line(proces || rsp);

-- Tipus de despesa <> G,P,T
dce.con.despeses_06b(2013,'D',rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
