---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Estadistica_01.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 28/11/2013                  -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Donat un parlament: la suma de totes les despeses dels darrers 4 anys (incloent les despeses 
   generals dels parlaments i les despeses associades als parlamentaris).
 * Es computa la suma de les despeses a partir de l'any actual fins els tres anys anteriors.
 * Mostra la informaci actual de la taula E1_CAMBRA_4ANYS
 * Executa el procediment ESTADISTICA_01_LLEGIR del package EST
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_cambra   IN  NUMBER,    -- Identificador bbdd de la cambra parlamentria
    o_rsp     OUT  VARCHAR2   -- Resultat de l'execuci del procediment estadstic
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria  
   - L'existncia de dades estadstiques de la cambra indicada     
-------------------------------------------------------------------------------------------------*/

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'ESTADISTICA_01_LLEGIR ';

-- EXECUCIONS CORRECTES:

dce.est.estadistica_01_llegir(7,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_01_llegir(10,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_01_llegir(13,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_cambra
dce.est.estadistica_01_llegir('',rsp); dbms_output.put_line(proces || rsp);

-- Cambra inexistent
dce.est.estadistica_01_llegir(98,rsp); dbms_output.put_line(proces || rsp);

-- No hi ha estadstica per la cambra indicada
dce.est.estadistica_01_llegir(2,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
