---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Estadistica_02.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 28/11/2013                  -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Donat un parlament i any: la diferencia en euros entre el parlamentari que ms despeses 
   associades t i el que menys. 
 * Mostra la informaci actual de la taula E2_DIFERENCIA_MEMBRES
 * Executa el procediment ESTADISTICA_02_LLEGIR del package EST
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_cambra       IN  NUMBER,    -- Identificador bbdd de la cambra parlamentria
    i_any          IN  NUMBER,    -- Any de les despeses
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment estadstic
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de la cambra parlamentria 
   - L'existncia de dades estadstiques de la cambra i any indicats    
-------------------------------------------------------------------------------------------------*/

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'ESTADISTICA_02_LLEGIR ';

-- EXECUCIONS CORRECTES:
dce.est.estadistica_02_llegir(7,2009,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(7,2010,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(7,2011,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(7,2012,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(7,2013,rsp); dbms_output.put_line(proces || rsp);

dce.est.estadistica_02_llegir(10,2009,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(10,2010,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(10,2011,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(10,2012,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(10,2013,rsp); dbms_output.put_line(proces || rsp);

dce.est.estadistica_02_llegir(13,2009,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(13,2010,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(13,2011,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(13,2012,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_02_llegir(13,2013,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_cambra
dce.est.estadistica_02_llegir('',2011,rsp); dbms_output.put_line(proces || rsp);

-- Falta el parmetre i_any
dce.est.estadistica_02_llegir(10,'',rsp); dbms_output.put_line(proces || rsp);

-- Cambra inexistent
dce.est.estadistica_02_llegir(98,2011,rsp); dbms_output.put_line(proces || rsp);

-- No hi ha estadstica per la cambra i any indicats
dce.est.estadistica_02_llegir(10,2015,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
