---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Estadistica_03.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 28/11/2013                  -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Donat un any concret: el parlament que ha tingut un total de despeses ms alt 
   (incloent les despeses generals dels parlaments i les despeses associades als parlamentaris).
 * Mostra la informaci actual de la taula E3_MAX_CAMBRA
 * Executa el procediment ESTADISTICA_03_LLEGIR del package EST
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_any          IN  NUMBER,    -- Any de les despeses
    o_rsp         OUT  VARCHAR2   -- Resultat de l'execuci del procediment estadstic
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia de dades estadstiques de l' any indicat
-------------------------------------------------------------------------------------------------*/

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'ESTADISTICA_03_LLEGIR ';

-- EXECUCIONS CORRECTES:

dce.est.estadistica_03_llegir(2009,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_03_llegir(2010,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_03_llegir(2011,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_03_llegir(2012,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_03_llegir(2013,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_any
dce.est.estadistica_03_llegir('',rsp); dbms_output.put_line(proces || rsp);

-- No hi ha estadstica per l'any indicat
dce.est.estadistica_03_llegir(2015,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
