---------------------------------------------------------------------------------------------------
-- UOC - ETIG - TFC Bases de dades relacionals	2013-2014 1r semestre
---------------------------------------------------------------------------------------------------
-- Base de Dades d'un Sistema Centralitzat de Control de Despesa Pblica dels Parlaments Europeus
---------------------------------------------------------------------------------------------------
-- Arxiu : 15_Con_Estadistica_04.sql   -- Autor    : Santi Alcayde Pagan   -- Aula: 1
-- Data  : 28/11/2013                  -- Consultor: Manel Rella Ruiz      
---------------------------------------------------------------------------------------------------
/* Donat un parlamentari: la despesa total que ha tingut els darrers 4 anys.
 * Es computa la suma de les despeses a partir de l'any actual fins els tres anys anteriors.
 * Mostra la informaci actual de la taula E4_MEMBRE_4ANYS
 * Executa el procediment ESTADISTICA_04_LLEGIR del package EST
 * El resultat de l'exeuci es guarda en la taula d'auditoria LOG_PROCEDIMENT
---------------------------------------------------------------------------------------------------
Parmetres a passar al procediment:
    i_membre   IN  NUMBER,    -- Identificador bbdd de membre de cambra parlamentria
    o_rsp     OUT  VARCHAR2   -- Resultat de l'execuci del procediment estadstic
---------------------------------------------------------------------------------------------------
Comprovacions i altres accions que fa:
   - Que els parmetres passats estiguin informats
   - L'existncia del/de la membre de cambra parlamentria
   - L'existncia de dades estadstiques del membre de cambra indicat 
-------------------------------------------------------------------------------------------------*/

SET SERVEROUTPUT ON;

DECLARE
    rsp    VARCHAR2(256); -- Resultat de l'execuci del procediment
    proces VARCHAR2(80);  -- Nom del procs
    
BEGIN
proces := 'ESTADISTICA_04_LLEGIR ';

-- EXECUCIONS CORRECTES:

dce.est.estadistica_04_llegir(1,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(2,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(3,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(4,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(5,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(6,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(7,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(8,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(9,rsp); dbms_output.put_line(proces || rsp);
dce.est.estadistica_04_llegir(10,rsp); dbms_output.put_line(proces || rsp);

-- EXECUCIONS ERRNIES:

-- Falta el parmetre i_membre
dce.est.estadistica_04_llegir('',rsp); dbms_output.put_line(proces || rsp);

-- Membre inexistent
dce.est.estadistica_04_llegir(198,rsp); dbms_output.put_line(proces || rsp);

-- No hi ha estadstica pel membre indicat
dce.est.estadistica_04_llegir(15,rsp); dbms_output.put_line(proces || rsp);

---------------------------------------------------------------------------------------------------
END;
/
